import { world, BlockPermutation } from '@minecraft/server';

//DOORS

//Black Door
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_black_door', {
        onPlayerInteract(e) {
            const { block, player } = e;
            const isUpperBlock = block.permutation.getState('old_villagers_plus:upper_block_bit');
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            const targetBlock = isUpperBlock ? block.below() : block.above();
            const currentOpenState = block.permutation.getState('old_villagers_plus:open_bit');
            const targetOpenState = targetBlock.permutation.getState('old_villagers_plus:open_bit');
            const newOpenState = !currentOpenState;
            const newTargetOpenState = !targetOpenState;
            const newBlockPermutation = BlockPermutation.resolve(block.typeId, {
                ...block.permutation.getAllStates(),
                'old_villagers_plus:open_bit': newOpenState
            });
            const newTargetBlockPermutation = BlockPermutation.resolve(targetBlock.typeId, {
                ...targetBlock.permutation.getAllStates(),
                'old_villagers_plus:open_bit': newTargetOpenState
            });
            block.setPermutation(newBlockPermutation);
            targetBlock.setPermutation(newTargetBlockPermutation);
            const sound = currentOpenState ? 'close.wooden_door' : 'open.wooden_door';
            player.playSound(sound);
            if (selectedItem?.typeId === 'minecraft:water_bucket') {
                player.playSound('bucket.empty_water');
                if (player.getGameMode() !== "creative") {
                    equipment.setEquipment('Mainhand', new ItemStack('minecraft:bucket', 1));
                }
            }
            if (block.typeId === 'old_villagers_plus:black_door' && selectedItem?.typeId === 'minecraft:water_bucket') {
                const currentStates = block.permutation.getAllStates();
                const structureName = 'old_villagers_plus:black_door';
                const { x, y, z } = block.location;
                world.structureManager.place(structureName, e.dimension, { x, y, z });
                const newBlock = e.dimension.getBlock({ x, y, z });
                const newStates = { ...newBlock.permutation.getAllStates(), ...currentStates };
                const newPermutation = BlockPermutation.resolve(newBlock.typeId, newStates);
                newBlock.setPermutation(newPermutation);
            }
        }
    });
});

//Blue Door
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_blue_door', {
        onPlayerInteract(e) {
            const { block, player } = e;
            const isUpperBlock = block.permutation.getState('old_villagers_plus:upper_block_bit');
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            const targetBlock = isUpperBlock ? block.below() : block.above();
            const currentOpenState = block.permutation.getState('old_villagers_plus:open_bit');
            const targetOpenState = targetBlock.permutation.getState('old_villagers_plus:open_bit');
            const newOpenState = !currentOpenState;
            const newTargetOpenState = !targetOpenState;
            const newBlockPermutation = BlockPermutation.resolve(block.typeId, {
                ...block.permutation.getAllStates(),
                'old_villagers_plus:open_bit': newOpenState
            });
            const newTargetBlockPermutation = BlockPermutation.resolve(targetBlock.typeId, {
                ...targetBlock.permutation.getAllStates(),
                'old_villagers_plus:open_bit': newTargetOpenState
            });
            block.setPermutation(newBlockPermutation);
            targetBlock.setPermutation(newTargetBlockPermutation);
            const sound = currentOpenState ? 'close.wooden_door' : 'open.wooden_door';
            player.playSound(sound);
            if (selectedItem?.typeId === 'minecraft:water_bucket') {
                player.playSound('bucket.empty_water');
                if (player.getGameMode() !== "creative") {
                    equipment.setEquipment('Mainhand', new ItemStack('minecraft:bucket', 1));
                }
            }
            if (block.typeId === 'old_villagers_plus:blue_door' && selectedItem?.typeId === 'minecraft:water_bucket') {
                const currentStates = block.permutation.getAllStates();
                const structureName = 'old_villagers_plus:blue_door';
                const { x, y, z } = block.location;
                world.structureManager.place(structureName, e.dimension, { x, y, z });
                const newBlock = e.dimension.getBlock({ x, y, z });
                const newStates = { ...newBlock.permutation.getAllStates(), ...currentStates };
                const newPermutation = BlockPermutation.resolve(newBlock.typeId, newStates);
                newBlock.setPermutation(newPermutation);
            }
        }
    });
});

//Brown Door
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_brown_door', {
        onPlayerInteract(e) {
            const { block, player } = e;
            const isUpperBlock = block.permutation.getState('old_villagers_plus:upper_block_bit');
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            const targetBlock = isUpperBlock ? block.below() : block.above();
            const currentOpenState = block.permutation.getState('old_villagers_plus:open_bit');
            const targetOpenState = targetBlock.permutation.getState('old_villagers_plus:open_bit');
            const newOpenState = !currentOpenState;
            const newTargetOpenState = !targetOpenState;
            const newBlockPermutation = BlockPermutation.resolve(block.typeId, {
                ...block.permutation.getAllStates(),
                'old_villagers_plus:open_bit': newOpenState
            });
            const newTargetBlockPermutation = BlockPermutation.resolve(targetBlock.typeId, {
                ...targetBlock.permutation.getAllStates(),
                'old_villagers_plus:open_bit': newTargetOpenState
            });
            block.setPermutation(newBlockPermutation);
            targetBlock.setPermutation(newTargetBlockPermutation);
            const sound = currentOpenState ? 'close.wooden_door' : 'open.wooden_door';
            player.playSound(sound);
            if (selectedItem?.typeId === 'minecraft:water_bucket') {
                player.playSound('bucket.empty_water');
                if (player.getGameMode() !== "creative") {
                    equipment.setEquipment('Mainhand', new ItemStack('minecraft:bucket', 1));
                }
            }
            if (block.typeId === 'old_villagers_plus:brown_door' && selectedItem?.typeId === 'minecraft:water_bucket') {
                const currentStates = block.permutation.getAllStates();
                const structureName = 'old_villagers_plus:brown_door';
                const { x, y, z } = block.location;
                world.structureManager.place(structureName, e.dimension, { x, y, z });
                const newBlock = e.dimension.getBlock({ x, y, z });
                const newStates = { ...newBlock.permutation.getAllStates(), ...currentStates };
                const newPermutation = BlockPermutation.resolve(newBlock.typeId, newStates);
                newBlock.setPermutation(newPermutation);
            }
        }
    });
});

//Cyan Door
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_cyan_door', {
        onPlayerInteract(e) {
            const { block, player } = e;
            const isUpperBlock = block.permutation.getState('old_villagers_plus:upper_block_bit');
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            const targetBlock = isUpperBlock ? block.below() : block.above();
            const currentOpenState = block.permutation.getState('old_villagers_plus:open_bit');
            const targetOpenState = targetBlock.permutation.getState('old_villagers_plus:open_bit');
            const newOpenState = !currentOpenState;
            const newTargetOpenState = !targetOpenState;
            const newBlockPermutation = BlockPermutation.resolve(block.typeId, {
                ...block.permutation.getAllStates(),
                'old_villagers_plus:open_bit': newOpenState
            });
            const newTargetBlockPermutation = BlockPermutation.resolve(targetBlock.typeId, {
                ...targetBlock.permutation.getAllStates(),
                'old_villagers_plus:open_bit': newTargetOpenState
            });
            block.setPermutation(newBlockPermutation);
            targetBlock.setPermutation(newTargetBlockPermutation);
            const sound = currentOpenState ? 'close.wooden_door' : 'open.wooden_door';
            player.playSound(sound);
            if (selectedItem?.typeId === 'minecraft:water_bucket') {
                player.playSound('bucket.empty_water');
                if (player.getGameMode() !== "creative") {
                    equipment.setEquipment('Mainhand', new ItemStack('minecraft:bucket', 1));
                }
            }
            if (block.typeId === 'old_villagers_plus:cyan_door' && selectedItem?.typeId === 'minecraft:water_bucket') {
                const currentStates = block.permutation.getAllStates();
                const structureName = 'old_villagers_plus:cyan_door';
                const { x, y, z } = block.location;
                world.structureManager.place(structureName, e.dimension, { x, y, z });
                const newBlock = e.dimension.getBlock({ x, y, z });
                const newStates = { ...newBlock.permutation.getAllStates(), ...currentStates };
                const newPermutation = BlockPermutation.resolve(newBlock.typeId, newStates);
                newBlock.setPermutation(newPermutation);
            }
        }
    });
});

//Dark Green Door
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_dark_green_door', {
        onPlayerInteract(e) {
            const { block, player } = e;
            const isUpperBlock = block.permutation.getState('old_villagers_plus:upper_block_bit');
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            const targetBlock = isUpperBlock ? block.below() : block.above();
            const currentOpenState = block.permutation.getState('old_villagers_plus:open_bit');
            const targetOpenState = targetBlock.permutation.getState('old_villagers_plus:open_bit');
            const newOpenState = !currentOpenState;
            const newTargetOpenState = !targetOpenState;
            const newBlockPermutation = BlockPermutation.resolve(block.typeId, {
                ...block.permutation.getAllStates(),
                'old_villagers_plus:open_bit': newOpenState
            });
            const newTargetBlockPermutation = BlockPermutation.resolve(targetBlock.typeId, {
                ...targetBlock.permutation.getAllStates(),
                'old_villagers_plus:open_bit': newTargetOpenState
            });
            block.setPermutation(newBlockPermutation);
            targetBlock.setPermutation(newTargetBlockPermutation);
            const sound = currentOpenState ? 'close.wooden_door' : 'open.wooden_door';
            player.playSound(sound);
            if (selectedItem?.typeId === 'minecraft:water_bucket') {
                player.playSound('bucket.empty_water');
                if (player.getGameMode() !== "creative") {
                    equipment.setEquipment('Mainhand', new ItemStack('minecraft:bucket', 1));
                }
            }
            if (block.typeId === 'old_villagers_plus:dark_green_door' && selectedItem?.typeId === 'minecraft:water_bucket') {
                const currentStates = block.permutation.getAllStates();
                const structureName = 'old_villagers_plus:dark_green_door';
                const { x, y, z } = block.location;
                world.structureManager.place(structureName, e.dimension, { x, y, z });
                const newBlock = e.dimension.getBlock({ x, y, z });
                const newStates = { ...newBlock.permutation.getAllStates(), ...currentStates };
                const newPermutation = BlockPermutation.resolve(newBlock.typeId, newStates);
                newBlock.setPermutation(newPermutation);
            }
        }
    });
});

//Dark Purple Door
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_dark_purple_door', {
        onPlayerInteract(e) {
            const { block, player } = e;
            const isUpperBlock = block.permutation.getState('old_villagers_plus:upper_block_bit');
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            const targetBlock = isUpperBlock ? block.below() : block.above();
            const currentOpenState = block.permutation.getState('old_villagers_plus:open_bit');
            const targetOpenState = targetBlock.permutation.getState('old_villagers_plus:open_bit');
            const newOpenState = !currentOpenState;
            const newTargetOpenState = !targetOpenState;
            const newBlockPermutation = BlockPermutation.resolve(block.typeId, {
                ...block.permutation.getAllStates(),
                'old_villagers_plus:open_bit': newOpenState
            });
            const newTargetBlockPermutation = BlockPermutation.resolve(targetBlock.typeId, {
                ...targetBlock.permutation.getAllStates(),
                'old_villagers_plus:open_bit': newTargetOpenState
            });
            block.setPermutation(newBlockPermutation);
            targetBlock.setPermutation(newTargetBlockPermutation);
            const sound = currentOpenState ? 'close.wooden_door' : 'open.wooden_door';
            player.playSound(sound);
            if (selectedItem?.typeId === 'minecraft:water_bucket') {
                player.playSound('bucket.empty_water');
                if (player.getGameMode() !== "creative") {
                    equipment.setEquipment('Mainhand', new ItemStack('minecraft:bucket', 1));
                }
            }
            if (block.typeId === 'old_villagers_plus:dark_purple_door' && selectedItem?.typeId === 'minecraft:water_bucket') {
                const currentStates = block.permutation.getAllStates();
                const structureName = 'old_villagers_plus:dark_purple_door';
                const { x, y, z } = block.location;
                world.structureManager.place(structureName, e.dimension, { x, y, z });
                const newBlock = e.dimension.getBlock({ x, y, z });
                const newStates = { ...newBlock.permutation.getAllStates(), ...currentStates };
                const newPermutation = BlockPermutation.resolve(newBlock.typeId, newStates);
                newBlock.setPermutation(newPermutation);
            }
        }
    });
});

//Green Door
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_green_door', {
        onPlayerInteract(e) {
            const { block, player } = e;
            const isUpperBlock = block.permutation.getState('old_villagers_plus:upper_block_bit');
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            const targetBlock = isUpperBlock ? block.below() : block.above();
            const currentOpenState = block.permutation.getState('old_villagers_plus:open_bit');
            const targetOpenState = targetBlock.permutation.getState('old_villagers_plus:open_bit');
            const newOpenState = !currentOpenState;
            const newTargetOpenState = !targetOpenState;
            const newBlockPermutation = BlockPermutation.resolve(block.typeId, {
                ...block.permutation.getAllStates(),
                'old_villagers_plus:open_bit': newOpenState
            });
            const newTargetBlockPermutation = BlockPermutation.resolve(targetBlock.typeId, {
                ...targetBlock.permutation.getAllStates(),
                'old_villagers_plus:open_bit': newTargetOpenState
            });
            block.setPermutation(newBlockPermutation);
            targetBlock.setPermutation(newTargetBlockPermutation);
            const sound = currentOpenState ? 'close.wooden_door' : 'open.wooden_door';
            player.playSound(sound);
            if (selectedItem?.typeId === 'minecraft:water_bucket') {
                player.playSound('bucket.empty_water');
                if (player.getGameMode() !== "creative") {
                    equipment.setEquipment('Mainhand', new ItemStack('minecraft:bucket', 1));
                }
            }
            if (block.typeId === 'old_villagers_plus:green_door' && selectedItem?.typeId === 'minecraft:water_bucket') {
                const currentStates = block.permutation.getAllStates();
                const structureName = 'old_villagers_plus:green_door';
                const { x, y, z } = block.location;
                world.structureManager.place(structureName, e.dimension, { x, y, z });
                const newBlock = e.dimension.getBlock({ x, y, z });
                const newStates = { ...newBlock.permutation.getAllStates(), ...currentStates };
                const newPermutation = BlockPermutation.resolve(newBlock.typeId, newStates);
                newBlock.setPermutation(newPermutation);
            }
        }
    });
});

//Grey Door
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_grey_door', {
        onPlayerInteract(e) {
            const { block, player } = e;
            const isUpperBlock = block.permutation.getState('old_villagers_plus:upper_block_bit');
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            const targetBlock = isUpperBlock ? block.below() : block.above();
            const currentOpenState = block.permutation.getState('old_villagers_plus:open_bit');
            const targetOpenState = targetBlock.permutation.getState('old_villagers_plus:open_bit');
            const newOpenState = !currentOpenState;
            const newTargetOpenState = !targetOpenState;
            const newBlockPermutation = BlockPermutation.resolve(block.typeId, {
                ...block.permutation.getAllStates(),
                'old_villagers_plus:open_bit': newOpenState
            });
            const newTargetBlockPermutation = BlockPermutation.resolve(targetBlock.typeId, {
                ...targetBlock.permutation.getAllStates(),
                'old_villagers_plus:open_bit': newTargetOpenState
            });
            block.setPermutation(newBlockPermutation);
            targetBlock.setPermutation(newTargetBlockPermutation);
            const sound = currentOpenState ? 'close.wooden_door' : 'open.wooden_door';
            player.playSound(sound);
            if (selectedItem?.typeId === 'minecraft:water_bucket') {
                player.playSound('bucket.empty_water');
                if (player.getGameMode() !== "creative") {
                    equipment.setEquipment('Mainhand', new ItemStack('minecraft:bucket', 1));
                }
            }
            if (block.typeId === 'old_villagers_plus:grey_door' && selectedItem?.typeId === 'minecraft:water_bucket') {
                const currentStates = block.permutation.getAllStates();
                const structureName = 'old_villagers_plus:grey_door';
                const { x, y, z } = block.location;
                world.structureManager.place(structureName, e.dimension, { x, y, z });
                const newBlock = e.dimension.getBlock({ x, y, z });
                const newStates = { ...newBlock.permutation.getAllStates(), ...currentStates };
                const newPermutation = BlockPermutation.resolve(newBlock.typeId, newStates);
                newBlock.setPermutation(newPermutation);
            }
        }
    });
});

//Light Blue Door
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_light_blue_door', {
        onPlayerInteract(e) {
            const { block, player } = e;
            const isUpperBlock = block.permutation.getState('old_villagers_plus:upper_block_bit');
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            const targetBlock = isUpperBlock ? block.below() : block.above();
            const currentOpenState = block.permutation.getState('old_villagers_plus:open_bit');
            const targetOpenState = targetBlock.permutation.getState('old_villagers_plus:open_bit');
            const newOpenState = !currentOpenState;
            const newTargetOpenState = !targetOpenState;
            const newBlockPermutation = BlockPermutation.resolve(block.typeId, {
                ...block.permutation.getAllStates(),
                'old_villagers_plus:open_bit': newOpenState
            });
            const newTargetBlockPermutation = BlockPermutation.resolve(targetBlock.typeId, {
                ...targetBlock.permutation.getAllStates(),
                'old_villagers_plus:open_bit': newTargetOpenState
            });
            block.setPermutation(newBlockPermutation);
            targetBlock.setPermutation(newTargetBlockPermutation);
            const sound = currentOpenState ? 'close.wooden_door' : 'open.wooden_door';
            player.playSound(sound);
            if (selectedItem?.typeId === 'minecraft:water_bucket') {
                player.playSound('bucket.empty_water');
                if (player.getGameMode() !== "creative") {
                    equipment.setEquipment('Mainhand', new ItemStack('minecraft:bucket', 1));
                }
            }
            if (block.typeId === 'old_villagers_plus:light_blue_door' && selectedItem?.typeId === 'minecraft:water_bucket') {
                const currentStates = block.permutation.getAllStates();
                const structureName = 'old_villagers_plus:light_blue_door';
                const { x, y, z } = block.location;
                world.structureManager.place(structureName, e.dimension, { x, y, z });
                const newBlock = e.dimension.getBlock({ x, y, z });
                const newStates = { ...newBlock.permutation.getAllStates(), ...currentStates };
                const newPermutation = BlockPermutation.resolve(newBlock.typeId, newStates);
                newBlock.setPermutation(newPermutation);
            }
        }
    });
});

//Light Grey Door
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_light_grey_door', {
        onPlayerInteract(e) {
            const { block, player } = e;
            const isUpperBlock = block.permutation.getState('old_villagers_plus:upper_block_bit');
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            const targetBlock = isUpperBlock ? block.below() : block.above();
            const currentOpenState = block.permutation.getState('old_villagers_plus:open_bit');
            const targetOpenState = targetBlock.permutation.getState('old_villagers_plus:open_bit');
            const newOpenState = !currentOpenState;
            const newTargetOpenState = !targetOpenState;
            const newBlockPermutation = BlockPermutation.resolve(block.typeId, {
                ...block.permutation.getAllStates(),
                'old_villagers_plus:open_bit': newOpenState
            });
            const newTargetBlockPermutation = BlockPermutation.resolve(targetBlock.typeId, {
                ...targetBlock.permutation.getAllStates(),
                'old_villagers_plus:open_bit': newTargetOpenState
            });
            block.setPermutation(newBlockPermutation);
            targetBlock.setPermutation(newTargetBlockPermutation);
            const sound = currentOpenState ? 'close.wooden_door' : 'open.wooden_door';
            player.playSound(sound);
            if (selectedItem?.typeId === 'minecraft:water_bucket') {
                player.playSound('bucket.empty_water');
                if (player.getGameMode() !== "creative") {
                    equipment.setEquipment('Mainhand', new ItemStack('minecraft:bucket', 1));
                }
            }
            if (block.typeId === 'old_villagers_plus:light_grey_door' && selectedItem?.typeId === 'minecraft:water_bucket') {
                const currentStates = block.permutation.getAllStates();
                const structureName = 'old_villagers_plus:light_grey_door';
                const { x, y, z } = block.location;
                world.structureManager.place(structureName, e.dimension, { x, y, z });
                const newBlock = e.dimension.getBlock({ x, y, z });
                const newStates = { ...newBlock.permutation.getAllStates(), ...currentStates };
                const newPermutation = BlockPermutation.resolve(newBlock.typeId, newStates);
                newBlock.setPermutation(newPermutation);
            }
        }
    });
});

//Orange Door
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_orange_door', {
        onPlayerInteract(e) {
            const { block, player } = e;
            const isUpperBlock = block.permutation.getState('old_villagers_plus:upper_block_bit');
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            const targetBlock = isUpperBlock ? block.below() : block.above();
            const currentOpenState = block.permutation.getState('old_villagers_plus:open_bit');
            const targetOpenState = targetBlock.permutation.getState('old_villagers_plus:open_bit');
            const newOpenState = !currentOpenState;
            const newTargetOpenState = !targetOpenState;
            const newBlockPermutation = BlockPermutation.resolve(block.typeId, {
                ...block.permutation.getAllStates(),
                'old_villagers_plus:open_bit': newOpenState
            });
            const newTargetBlockPermutation = BlockPermutation.resolve(targetBlock.typeId, {
                ...targetBlock.permutation.getAllStates(),
                'old_villagers_plus:open_bit': newTargetOpenState
            });
            block.setPermutation(newBlockPermutation);
            targetBlock.setPermutation(newTargetBlockPermutation);
            const sound = currentOpenState ? 'close.wooden_door' : 'open.wooden_door';
            player.playSound(sound);
            if (selectedItem?.typeId === 'minecraft:water_bucket') {
                player.playSound('bucket.empty_water');
                if (player.getGameMode() !== "creative") {
                    equipment.setEquipment('Mainhand', new ItemStack('minecraft:bucket', 1));
                }
            }
            if (block.typeId === 'old_villagers_plus:orange_door' && selectedItem?.typeId === 'minecraft:water_bucket') {
                const currentStates = block.permutation.getAllStates();
                const structureName = 'old_villagers_plus:orange_door';
                const { x, y, z } = block.location;
                world.structureManager.place(structureName, e.dimension, { x, y, z });
                const newBlock = e.dimension.getBlock({ x, y, z });
                const newStates = { ...newBlock.permutation.getAllStates(), ...currentStates };
                const newPermutation = BlockPermutation.resolve(newBlock.typeId, newStates);
                newBlock.setPermutation(newPermutation);
            }
        }
    });
});

//Pink Door
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_pink_door', {
        onPlayerInteract(e) {
            const { block, player } = e;
            const isUpperBlock = block.permutation.getState('old_villagers_plus:upper_block_bit');
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            const targetBlock = isUpperBlock ? block.below() : block.above();
            const currentOpenState = block.permutation.getState('old_villagers_plus:open_bit');
            const targetOpenState = targetBlock.permutation.getState('old_villagers_plus:open_bit');
            const newOpenState = !currentOpenState;
            const newTargetOpenState = !targetOpenState;
            const newBlockPermutation = BlockPermutation.resolve(block.typeId, {
                ...block.permutation.getAllStates(),
                'old_villagers_plus:open_bit': newOpenState
            });
            const newTargetBlockPermutation = BlockPermutation.resolve(targetBlock.typeId, {
                ...targetBlock.permutation.getAllStates(),
                'old_villagers_plus:open_bit': newTargetOpenState
            });
            block.setPermutation(newBlockPermutation);
            targetBlock.setPermutation(newTargetBlockPermutation);
            const sound = currentOpenState ? 'close.wooden_door' : 'open.wooden_door';
            player.playSound(sound);
            if (selectedItem?.typeId === 'minecraft:water_bucket') {
                player.playSound('bucket.empty_water');
                if (player.getGameMode() !== "creative") {
                    equipment.setEquipment('Mainhand', new ItemStack('minecraft:bucket', 1));
                }
            }
            if (block.typeId === 'old_villagers_plus:pink_door' && selectedItem?.typeId === 'minecraft:water_bucket') {
                const currentStates = block.permutation.getAllStates();
                const structureName = 'old_villagers_plus:pink_door';
                const { x, y, z } = block.location;
                world.structureManager.place(structureName, e.dimension, { x, y, z });
                const newBlock = e.dimension.getBlock({ x, y, z });
                const newStates = { ...newBlock.permutation.getAllStates(), ...currentStates };
                const newPermutation = BlockPermutation.resolve(newBlock.typeId, newStates);
                newBlock.setPermutation(newPermutation);
            }
        }
    });
});

//Purple Door
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_purple_door', {
        onPlayerInteract(e) {
            const { block, player } = e;
            const isUpperBlock = block.permutation.getState('old_villagers_plus:upper_block_bit');
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            const targetBlock = isUpperBlock ? block.below() : block.above();
            const currentOpenState = block.permutation.getState('old_villagers_plus:open_bit');
            const targetOpenState = targetBlock.permutation.getState('old_villagers_plus:open_bit');
            const newOpenState = !currentOpenState;
            const newTargetOpenState = !targetOpenState;
            const newBlockPermutation = BlockPermutation.resolve(block.typeId, {
                ...block.permutation.getAllStates(),
                'old_villagers_plus:open_bit': newOpenState
            });
            const newTargetBlockPermutation = BlockPermutation.resolve(targetBlock.typeId, {
                ...targetBlock.permutation.getAllStates(),
                'old_villagers_plus:open_bit': newTargetOpenState
            });
            block.setPermutation(newBlockPermutation);
            targetBlock.setPermutation(newTargetBlockPermutation);
            const sound = currentOpenState ? 'close.wooden_door' : 'open.wooden_door';
            player.playSound(sound);
            if (selectedItem?.typeId === 'minecraft:water_bucket') {
                player.playSound('bucket.empty_water');
                if (player.getGameMode() !== "creative") {
                    equipment.setEquipment('Mainhand', new ItemStack('minecraft:bucket', 1));
                }
            }
            if (block.typeId === 'old_villagers_plus:purple_door' && selectedItem?.typeId === 'minecraft:water_bucket') {
                const currentStates = block.permutation.getAllStates();
                const structureName = 'old_villagers_plus:purple_door';
                const { x, y, z } = block.location;
                world.structureManager.place(structureName, e.dimension, { x, y, z });
                const newBlock = e.dimension.getBlock({ x, y, z });
                const newStates = { ...newBlock.permutation.getAllStates(), ...currentStates };
                const newPermutation = BlockPermutation.resolve(newBlock.typeId, newStates);
                newBlock.setPermutation(newPermutation);
            }
        }
    });
});

//Red Door
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_red_door', {
        onPlayerInteract(e) {
            const { block, player } = e;
            const isUpperBlock = block.permutation.getState('old_villagers_plus:upper_block_bit');
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            const targetBlock = isUpperBlock ? block.below() : block.above();
            const currentOpenState = block.permutation.getState('old_villagers_plus:open_bit');
            const targetOpenState = targetBlock.permutation.getState('old_villagers_plus:open_bit');
            const newOpenState = !currentOpenState;
            const newTargetOpenState = !targetOpenState;
            const newBlockPermutation = BlockPermutation.resolve(block.typeId, {
                ...block.permutation.getAllStates(),
                'old_villagers_plus:open_bit': newOpenState
            });
            const newTargetBlockPermutation = BlockPermutation.resolve(targetBlock.typeId, {
                ...targetBlock.permutation.getAllStates(),
                'old_villagers_plus:open_bit': newTargetOpenState
            });
            block.setPermutation(newBlockPermutation);
            targetBlock.setPermutation(newTargetBlockPermutation);
            const sound = currentOpenState ? 'close.wooden_door' : 'open.wooden_door';
            player.playSound(sound);
            if (selectedItem?.typeId === 'minecraft:water_bucket') {
                player.playSound('bucket.empty_water');
                if (player.getGameMode() !== "creative") {
                    equipment.setEquipment('Mainhand', new ItemStack('minecraft:bucket', 1));
                }
            }
            if (block.typeId === 'old_villagers_plus:red_door' && selectedItem?.typeId === 'minecraft:water_bucket') {
                const currentStates = block.permutation.getAllStates();
                const structureName = 'old_villagers_plus:red_door';
                const { x, y, z } = block.location;
                world.structureManager.place(structureName, e.dimension, { x, y, z });
                const newBlock = e.dimension.getBlock({ x, y, z });
                const newStates = { ...newBlock.permutation.getAllStates(), ...currentStates };
                const newPermutation = BlockPermutation.resolve(newBlock.typeId, newStates);
                newBlock.setPermutation(newPermutation);
            }
        }
    });
});

//White Door
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_white_door', {
        onPlayerInteract(e) {
            const { block, player } = e;
            const isUpperBlock = block.permutation.getState('old_villagers_plus:upper_block_bit');
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            const targetBlock = isUpperBlock ? block.below() : block.above();
            const currentOpenState = block.permutation.getState('old_villagers_plus:open_bit');
            const targetOpenState = targetBlock.permutation.getState('old_villagers_plus:open_bit');
            const newOpenState = !currentOpenState;
            const newTargetOpenState = !targetOpenState;
            const newBlockPermutation = BlockPermutation.resolve(block.typeId, {
                ...block.permutation.getAllStates(),
                'old_villagers_plus:open_bit': newOpenState
            });
            const newTargetBlockPermutation = BlockPermutation.resolve(targetBlock.typeId, {
                ...targetBlock.permutation.getAllStates(),
                'old_villagers_plus:open_bit': newTargetOpenState
            });
            block.setPermutation(newBlockPermutation);
            targetBlock.setPermutation(newTargetBlockPermutation);
            const sound = currentOpenState ? 'close.wooden_door' : 'open.wooden_door';
            player.playSound(sound);
            if (selectedItem?.typeId === 'minecraft:water_bucket') {
                player.playSound('bucket.empty_water');
                if (player.getGameMode() !== "creative") {
                    equipment.setEquipment('Mainhand', new ItemStack('minecraft:bucket', 1));
                }
            }
            if (block.typeId === 'old_villagers_plus:white_door' && selectedItem?.typeId === 'minecraft:water_bucket') {
                const currentStates = block.permutation.getAllStates();
                const structureName = 'old_villagers_plus:white_door';
                const { x, y, z } = block.location;
                world.structureManager.place(structureName, e.dimension, { x, y, z });
                const newBlock = e.dimension.getBlock({ x, y, z });
                const newStates = { ...newBlock.permutation.getAllStates(), ...currentStates };
                const newPermutation = BlockPermutation.resolve(newBlock.typeId, newStates);
                newBlock.setPermutation(newPermutation);
            }
        }
    });
});

//Yellow Door
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_yellow_door', {
        onPlayerInteract(e) {
            const { block, player } = e;
            const isUpperBlock = block.permutation.getState('old_villagers_plus:upper_block_bit');
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            const targetBlock = isUpperBlock ? block.below() : block.above();
            const currentOpenState = block.permutation.getState('old_villagers_plus:open_bit');
            const targetOpenState = targetBlock.permutation.getState('old_villagers_plus:open_bit');
            const newOpenState = !currentOpenState;
            const newTargetOpenState = !targetOpenState;
            const newBlockPermutation = BlockPermutation.resolve(block.typeId, {
                ...block.permutation.getAllStates(),
                'old_villagers_plus:open_bit': newOpenState
            });
            const newTargetBlockPermutation = BlockPermutation.resolve(targetBlock.typeId, {
                ...targetBlock.permutation.getAllStates(),
                'old_villagers_plus:open_bit': newTargetOpenState
            });
            block.setPermutation(newBlockPermutation);
            targetBlock.setPermutation(newTargetBlockPermutation);
            const sound = currentOpenState ? 'close.wooden_door' : 'open.wooden_door';
            player.playSound(sound);
            if (selectedItem?.typeId === 'minecraft:water_bucket') {
                player.playSound('bucket.empty_water');
                if (player.getGameMode() !== "creative") {
                    equipment.setEquipment('Mainhand', new ItemStack('minecraft:bucket', 1));
                }
            }
            if (block.typeId === 'old_villagers_plus:yellow_door' && selectedItem?.typeId === 'minecraft:water_bucket') {
                const currentStates = block.permutation.getAllStates();
                const structureName = 'old_villagers_plus:yellow_door';
                const { x, y, z } = block.location;
                world.structureManager.place(structureName, e.dimension, { x, y, z });
                const newBlock = e.dimension.getBlock({ x, y, z });
                const newStates = { ...newBlock.permutation.getAllStates(), ...currentStates };
                const newPermutation = BlockPermutation.resolve(newBlock.typeId, newStates);
                newBlock.setPermutation(newPermutation);
            }
        }
    });
});

//SLABS

//Black Slab
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_black_slab', {
        onPlayerInteract(e) {
            const { block, player, face } = e;
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            if (selectedItem?.typeId === block.typeId && !block.permutation.getState('old_villagers_plus:double')) {
                const verticalHalf = block.permutation.getState('minecraft:vertical_half');
                const isBottomUp = verticalHalf === 'bottom' && face === 'Up';
                const isTopDown = verticalHalf === 'top' && face === 'Down';
                if (isBottomUp || isTopDown) {
                    if (player.getGameMode() !== "creative") {
                        if (selectedItem.amount > 1) {
                            selectedItem.amount -= 1;
                            equipment.setEquipment('Mainhand', selectedItem);
                        } else if (selectedItem.amount === 1) {
                            equipment.setEquipment('Mainhand', undefined); // Clear the slot if only 1 item left
                        }
                    }
                    block.setPermutation(block.permutation.withState('old_villagers_plus:double', true));
                    block.setWaterlogged(false);
                    player.playSound('use.wood');
                }
            }
            if (selectedItem?.typeId === 'minecraft:water_bucket' && !block.permutation.getState('old_villagers_plus:waterlogged') && !block.permutation.getState('old_villagers_plus:double')) {
                player.playSound('bucket.empty_water');
                if (player.getGameMode() !== "creative") {
                    equipment.setEquipment('Mainhand', new ItemStack('minecraft:bucket', 1));
                }
                block.setPermutation(block.permutation.withState('old_villagers_plus:waterlogged', true));
                const verticalHalf = block.permutation.getState('minecraft:vertical_half');
                const slabType = block.typeId.split(':')[1];
                const structureName = (verticalHalf === 'bottom') ? `mystructure:${slabType}_bottomSlab` : `mystructure:${slabType}_topSlab`;
                const { x, y, z } = block;
                world.structureManager.place(structureName, e.dimension, { x, y, z });
            }
        }
    });
});

//Blue Slab
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_blue_slab', {
        onPlayerInteract(e) {
            const { block, player, face } = e;
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            if (selectedItem?.typeId === block.typeId && !block.permutation.getState('old_villagers_plus:double')) {
                const verticalHalf = block.permutation.getState('minecraft:vertical_half');
                const isBottomUp = verticalHalf === 'bottom' && face === 'Up';
                const isTopDown = verticalHalf === 'top' && face === 'Down';
                if (isBottomUp || isTopDown) {
                    if (player.getGameMode() !== "creative") {
                        if (selectedItem.amount > 1) {
                            selectedItem.amount -= 1;
                            equipment.setEquipment('Mainhand', selectedItem);
                        } else if (selectedItem.amount === 1) {
                            equipment.setEquipment('Mainhand', undefined); // Clear the slot if only 1 item left
                        }
                    }
                    block.setPermutation(block.permutation.withState('old_villagers_plus:double', true));
                    block.setWaterlogged(false);
                    player.playSound('use.wood');
                }
            }
            if (selectedItem?.typeId === 'minecraft:water_bucket' && !block.permutation.getState('old_villagers_plus:waterlogged') && !block.permutation.getState('old_villagers_plus:double')) {
                player.playSound('bucket.empty_water');
                if (player.getGameMode() !== "creative") {
                    equipment.setEquipment('Mainhand', new ItemStack('minecraft:bucket', 1));
                }
                block.setPermutation(block.permutation.withState('old_villagers_plus:waterlogged', true));
                const verticalHalf = block.permutation.getState('minecraft:vertical_half');
                const slabType = block.typeId.split(':')[1];
                const structureName = (verticalHalf === 'bottom') ? `mystructure:${slabType}_bottomSlab` : `mystructure:${slabType}_topSlab`;
                const { x, y, z } = block;
                world.structureManager.place(structureName, e.dimension, { x, y, z });
            }
        }
    });
});

//Brown Slab
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_brown_slab', {
        onPlayerInteract(e) {
            const { block, player, face } = e;
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            if (selectedItem?.typeId === block.typeId && !block.permutation.getState('old_villagers_plus:double')) {
                const verticalHalf = block.permutation.getState('minecraft:vertical_half');
                const isBottomUp = verticalHalf === 'bottom' && face === 'Up';
                const isTopDown = verticalHalf === 'top' && face === 'Down';
                if (isBottomUp || isTopDown) {
                    if (player.getGameMode() !== "creative") {
                        if (selectedItem.amount > 1) {
                            selectedItem.amount -= 1;
                            equipment.setEquipment('Mainhand', selectedItem);
                        } else if (selectedItem.amount === 1) {
                            equipment.setEquipment('Mainhand', undefined); // Clear the slot if only 1 item left
                        }
                    }
                    block.setPermutation(block.permutation.withState('old_villagers_plus:double', true));
                    block.setWaterlogged(false);
                    player.playSound('use.wood');
                }
            }
            if (selectedItem?.typeId === 'minecraft:water_bucket' && !block.permutation.getState('old_villagers_plus:waterlogged') && !block.permutation.getState('old_villagers_plus:double')) {
                player.playSound('bucket.empty_water');
                if (player.getGameMode() !== "creative") {
                    equipment.setEquipment('Mainhand', new ItemStack('minecraft:bucket', 1));
                }
                block.setPermutation(block.permutation.withState('old_villagers_plus:waterlogged', true));
                const verticalHalf = block.permutation.getState('minecraft:vertical_half');
                const slabType = block.typeId.split(':')[1];
                const structureName = (verticalHalf === 'bottom') ? `mystructure:${slabType}_bottomSlab` : `mystructure:${slabType}_topSlab`;
                const { x, y, z } = block;
                world.structureManager.place(structureName, e.dimension, { x, y, z });
            }
        }
    });
});

//Cyan Slab
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_cyan_slab', {
        onPlayerInteract(e) {
            const { block, player, face } = e;
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            if (selectedItem?.typeId === block.typeId && !block.permutation.getState('old_villagers_plus:double')) {
                const verticalHalf = block.permutation.getState('minecraft:vertical_half');
                const isBottomUp = verticalHalf === 'bottom' && face === 'Up';
                const isTopDown = verticalHalf === 'top' && face === 'Down';
                if (isBottomUp || isTopDown) {
                    if (player.getGameMode() !== "creative") {
                        if (selectedItem.amount > 1) {
                            selectedItem.amount -= 1;
                            equipment.setEquipment('Mainhand', selectedItem);
                        } else if (selectedItem.amount === 1) {
                            equipment.setEquipment('Mainhand', undefined); // Clear the slot if only 1 item left
                        }
                    }
                    block.setPermutation(block.permutation.withState('old_villagers_plus:double', true));
                    block.setWaterlogged(false);
                    player.playSound('use.wood');
                }
            }
            if (selectedItem?.typeId === 'minecraft:water_bucket' && !block.permutation.getState('old_villagers_plus:waterlogged') && !block.permutation.getState('old_villagers_plus:double')) {
                player.playSound('bucket.empty_water');
                if (player.getGameMode() !== "creative") {
                    equipment.setEquipment('Mainhand', new ItemStack('minecraft:bucket', 1));
                }
                block.setPermutation(block.permutation.withState('old_villagers_plus:waterlogged', true));
                const verticalHalf = block.permutation.getState('minecraft:vertical_half');
                const slabType = block.typeId.split(':')[1];
                const structureName = (verticalHalf === 'bottom') ? `mystructure:${slabType}_bottomSlab` : `mystructure:${slabType}_topSlab`;
                const { x, y, z } = block;
                world.structureManager.place(structureName, e.dimension, { x, y, z });
            }
        }
    });
});

//Dark Green Slab
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_dark_green_slab', {
        onPlayerInteract(e) {
            const { block, player, face } = e;
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            if (selectedItem?.typeId === block.typeId && !block.permutation.getState('old_villagers_plus:double')) {
                const verticalHalf = block.permutation.getState('minecraft:vertical_half');
                const isBottomUp = verticalHalf === 'bottom' && face === 'Up';
                const isTopDown = verticalHalf === 'top' && face === 'Down';
                if (isBottomUp || isTopDown) {
                    if (player.getGameMode() !== "creative") {
                        if (selectedItem.amount > 1) {
                            selectedItem.amount -= 1;
                            equipment.setEquipment('Mainhand', selectedItem);
                        } else if (selectedItem.amount === 1) {
                            equipment.setEquipment('Mainhand', undefined); // Clear the slot if only 1 item left
                        }
                    }
                    block.setPermutation(block.permutation.withState('old_villagers_plus:double', true));
                    block.setWaterlogged(false);
                    player.playSound('use.wood');
                }
            }
            if (selectedItem?.typeId === 'minecraft:water_bucket' && !block.permutation.getState('old_villagers_plus:waterlogged') && !block.permutation.getState('old_villagers_plus:double')) {
                player.playSound('bucket.empty_water');
                if (player.getGameMode() !== "creative") {
                    equipment.setEquipment('Mainhand', new ItemStack('minecraft:bucket', 1));
                }
                block.setPermutation(block.permutation.withState('old_villagers_plus:waterlogged', true));
                const verticalHalf = block.permutation.getState('minecraft:vertical_half');
                const slabType = block.typeId.split(':')[1];
                const structureName = (verticalHalf === 'bottom') ? `mystructure:${slabType}_bottomSlab` : `mystructure:${slabType}_topSlab`;
                const { x, y, z } = block;
                world.structureManager.place(structureName, e.dimension, { x, y, z });
            }
        }
    });
});

//Dark Purple Slab
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_dark_purple_slab', {
        onPlayerInteract(e) {
            const { block, player, face } = e;
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            if (selectedItem?.typeId === block.typeId && !block.permutation.getState('old_villagers_plus:double')) {
                const verticalHalf = block.permutation.getState('minecraft:vertical_half');
                const isBottomUp = verticalHalf === 'bottom' && face === 'Up';
                const isTopDown = verticalHalf === 'top' && face === 'Down';
                if (isBottomUp || isTopDown) {
                    if (player.getGameMode() !== "creative") {
                        if (selectedItem.amount > 1) {
                            selectedItem.amount -= 1;
                            equipment.setEquipment('Mainhand', selectedItem);
                        } else if (selectedItem.amount === 1) {
                            equipment.setEquipment('Mainhand', undefined); // Clear the slot if only 1 item left
                        }
                    }
                    block.setPermutation(block.permutation.withState('old_villagers_plus:double', true));
                    block.setWaterlogged(false);
                    player.playSound('use.wood');
                }
            }
            if (selectedItem?.typeId === 'minecraft:water_bucket' && !block.permutation.getState('old_villagers_plus:waterlogged') && !block.permutation.getState('old_villagers_plus:double')) {
                player.playSound('bucket.empty_water');
                if (player.getGameMode() !== "creative") {
                    equipment.setEquipment('Mainhand', new ItemStack('minecraft:bucket', 1));
                }
                block.setPermutation(block.permutation.withState('old_villagers_plus:waterlogged', true));
                const verticalHalf = block.permutation.getState('minecraft:vertical_half');
                const slabType = block.typeId.split(':')[1];
                const structureName = (verticalHalf === 'bottom') ? `mystructure:${slabType}_bottomSlab` : `mystructure:${slabType}_topSlab`;
                const { x, y, z } = block;
                world.structureManager.place(structureName, e.dimension, { x, y, z });
            }
        }
    });
});

//Green Slab
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_green_slab', {
        onPlayerInteract(e) {
            const { block, player, face } = e;
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            if (selectedItem?.typeId === block.typeId && !block.permutation.getState('old_villagers_plus:double')) {
                const verticalHalf = block.permutation.getState('minecraft:vertical_half');
                const isBottomUp = verticalHalf === 'bottom' && face === 'Up';
                const isTopDown = verticalHalf === 'top' && face === 'Down';
                if (isBottomUp || isTopDown) {
                    if (player.getGameMode() !== "creative") {
                        if (selectedItem.amount > 1) {
                            selectedItem.amount -= 1;
                            equipment.setEquipment('Mainhand', selectedItem);
                        } else if (selectedItem.amount === 1) {
                            equipment.setEquipment('Mainhand', undefined); // Clear the slot if only 1 item left
                        }
                    }
                    block.setPermutation(block.permutation.withState('old_villagers_plus:double', true));
                    block.setWaterlogged(false);
                    player.playSound('use.wood');
                }
            }
            if (selectedItem?.typeId === 'minecraft:water_bucket' && !block.permutation.getState('old_villagers_plus:waterlogged') && !block.permutation.getState('old_villagers_plus:double')) {
                player.playSound('bucket.empty_water');
                if (player.getGameMode() !== "creative") {
                    equipment.setEquipment('Mainhand', new ItemStack('minecraft:bucket', 1));
                }
                block.setPermutation(block.permutation.withState('old_villagers_plus:waterlogged', true));
                const verticalHalf = block.permutation.getState('minecraft:vertical_half');
                const slabType = block.typeId.split(':')[1];
                const structureName = (verticalHalf === 'bottom') ? `mystructure:${slabType}_bottomSlab` : `mystructure:${slabType}_topSlab`;
                const { x, y, z } = block;
                world.structureManager.place(structureName, e.dimension, { x, y, z });
            }
        }
    });
});

//Grey Slab
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_grey_slab', {
        onPlayerInteract(e) {
            const { block, player, face } = e;
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            if (selectedItem?.typeId === block.typeId && !block.permutation.getState('old_villagers_plus:double')) {
                const verticalHalf = block.permutation.getState('minecraft:vertical_half');
                const isBottomUp = verticalHalf === 'bottom' && face === 'Up';
                const isTopDown = verticalHalf === 'top' && face === 'Down';
                if (isBottomUp || isTopDown) {
                    if (player.getGameMode() !== "creative") {
                        if (selectedItem.amount > 1) {
                            selectedItem.amount -= 1;
                            equipment.setEquipment('Mainhand', selectedItem);
                        } else if (selectedItem.amount === 1) {
                            equipment.setEquipment('Mainhand', undefined); // Clear the slot if only 1 item left
                        }
                    }
                    block.setPermutation(block.permutation.withState('old_villagers_plus:double', true));
                    block.setWaterlogged(false);
                    player.playSound('use.wood');
                }
            }
            if (selectedItem?.typeId === 'minecraft:water_bucket' && !block.permutation.getState('old_villagers_plus:waterlogged') && !block.permutation.getState('old_villagers_plus:double')) {
                player.playSound('bucket.empty_water');
                if (player.getGameMode() !== "creative") {
                    equipment.setEquipment('Mainhand', new ItemStack('minecraft:bucket', 1));
                }
                block.setPermutation(block.permutation.withState('old_villagers_plus:waterlogged', true));
                const verticalHalf = block.permutation.getState('minecraft:vertical_half');
                const slabType = block.typeId.split(':')[1];
                const structureName = (verticalHalf === 'bottom') ? `mystructure:${slabType}_bottomSlab` : `mystructure:${slabType}_topSlab`;
                const { x, y, z } = block;
                world.structureManager.place(structureName, e.dimension, { x, y, z });
            }
        }
    });
});

//Light Blue Slab
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_light_blue_slab', {
        onPlayerInteract(e) {
            const { block, player, face } = e;
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            if (selectedItem?.typeId === block.typeId && !block.permutation.getState('old_villagers_plus:double')) {
                const verticalHalf = block.permutation.getState('minecraft:vertical_half');
                const isBottomUp = verticalHalf === 'bottom' && face === 'Up';
                const isTopDown = verticalHalf === 'top' && face === 'Down';
                if (isBottomUp || isTopDown) {
                    if (player.getGameMode() !== "creative") {
                        if (selectedItem.amount > 1) {
                            selectedItem.amount -= 1;
                            equipment.setEquipment('Mainhand', selectedItem);
                        } else if (selectedItem.amount === 1) {
                            equipment.setEquipment('Mainhand', undefined); // Clear the slot if only 1 item left
                        }
                    }
                    block.setPermutation(block.permutation.withState('old_villagers_plus:double', true));
                    block.setWaterlogged(false);
                    player.playSound('use.wood');
                }
            }
            if (selectedItem?.typeId === 'minecraft:water_bucket' && !block.permutation.getState('old_villagers_plus:waterlogged') && !block.permutation.getState('old_villagers_plus:double')) {
                player.playSound('bucket.empty_water');
                if (player.getGameMode() !== "creative") {
                    equipment.setEquipment('Mainhand', new ItemStack('minecraft:bucket', 1));
                }
                block.setPermutation(block.permutation.withState('old_villagers_plus:waterlogged', true));
                const verticalHalf = block.permutation.getState('minecraft:vertical_half');
                const slabType = block.typeId.split(':')[1];
                const structureName = (verticalHalf === 'bottom') ? `mystructure:${slabType}_bottomSlab` : `mystructure:${slabType}_topSlab`;
                const { x, y, z } = block;
                world.structureManager.place(structureName, e.dimension, { x, y, z });
            }
        }
    });
});

//Light Grey Slab
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_light_grey_slab', {
        onPlayerInteract(e) {
            const { block, player, face } = e;
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            if (selectedItem?.typeId === block.typeId && !block.permutation.getState('old_villagers_plus:double')) {
                const verticalHalf = block.permutation.getState('minecraft:vertical_half');
                const isBottomUp = verticalHalf === 'bottom' && face === 'Up';
                const isTopDown = verticalHalf === 'top' && face === 'Down';
                if (isBottomUp || isTopDown) {
                    if (player.getGameMode() !== "creative") {
                        if (selectedItem.amount > 1) {
                            selectedItem.amount -= 1;
                            equipment.setEquipment('Mainhand', selectedItem);
                        } else if (selectedItem.amount === 1) {
                            equipment.setEquipment('Mainhand', undefined); // Clear the slot if only 1 item left
                        }
                    }
                    block.setPermutation(block.permutation.withState('old_villagers_plus:double', true));
                    block.setWaterlogged(false);
                    player.playSound('use.wood');
                }
            }
            if (selectedItem?.typeId === 'minecraft:water_bucket' && !block.permutation.getState('old_villagers_plus:waterlogged') && !block.permutation.getState('old_villagers_plus:double')) {
                player.playSound('bucket.empty_water');
                if (player.getGameMode() !== "creative") {
                    equipment.setEquipment('Mainhand', new ItemStack('minecraft:bucket', 1));
                }
                block.setPermutation(block.permutation.withState('old_villagers_plus:waterlogged', true));
                const verticalHalf = block.permutation.getState('minecraft:vertical_half');
                const slabType = block.typeId.split(':')[1];
                const structureName = (verticalHalf === 'bottom') ? `mystructure:${slabType}_bottomSlab` : `mystructure:${slabType}_topSlab`;
                const { x, y, z } = block;
                world.structureManager.place(structureName, e.dimension, { x, y, z });
            }
        }
    });
});

//Orange Slab
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_orange_slab', {
        onPlayerInteract(e) {
            const { block, player, face } = e;
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            if (selectedItem?.typeId === block.typeId && !block.permutation.getState('old_villagers_plus:double')) {
                const verticalHalf = block.permutation.getState('minecraft:vertical_half');
                const isBottomUp = verticalHalf === 'bottom' && face === 'Up';
                const isTopDown = verticalHalf === 'top' && face === 'Down';
                if (isBottomUp || isTopDown) {
                    if (player.getGameMode() !== "creative") {
                        if (selectedItem.amount > 1) {
                            selectedItem.amount -= 1;
                            equipment.setEquipment('Mainhand', selectedItem);
                        } else if (selectedItem.amount === 1) {
                            equipment.setEquipment('Mainhand', undefined); // Clear the slot if only 1 item left
                        }
                    }
                    block.setPermutation(block.permutation.withState('old_villagers_plus:double', true));
                    block.setWaterlogged(false);
                    player.playSound('use.wood');
                }
            }
            if (selectedItem?.typeId === 'minecraft:water_bucket' && !block.permutation.getState('old_villagers_plus:waterlogged') && !block.permutation.getState('old_villagers_plus:double')) {
                player.playSound('bucket.empty_water');
                if (player.getGameMode() !== "creative") {
                    equipment.setEquipment('Mainhand', new ItemStack('minecraft:bucket', 1));
                }
                block.setPermutation(block.permutation.withState('old_villagers_plus:waterlogged', true));
                const verticalHalf = block.permutation.getState('minecraft:vertical_half');
                const slabType = block.typeId.split(':')[1];
                const structureName = (verticalHalf === 'bottom') ? `mystructure:${slabType}_bottomSlab` : `mystructure:${slabType}_topSlab`;
                const { x, y, z } = block;
                world.structureManager.place(structureName, e.dimension, { x, y, z });
            }
        }
    });
});

//Pink Slab
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_pink_slab', {
        onPlayerInteract(e) {
            const { block, player, face } = e;
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            if (selectedItem?.typeId === block.typeId && !block.permutation.getState('old_villagers_plus:double')) {
                const verticalHalf = block.permutation.getState('minecraft:vertical_half');
                const isBottomUp = verticalHalf === 'bottom' && face === 'Up';
                const isTopDown = verticalHalf === 'top' && face === 'Down';
                if (isBottomUp || isTopDown) {
                    if (player.getGameMode() !== "creative") {
                        if (selectedItem.amount > 1) {
                            selectedItem.amount -= 1;
                            equipment.setEquipment('Mainhand', selectedItem);
                        } else if (selectedItem.amount === 1) {
                            equipment.setEquipment('Mainhand', undefined); // Clear the slot if only 1 item left
                        }
                    }
                    block.setPermutation(block.permutation.withState('old_villagers_plus:double', true));
                    block.setWaterlogged(false);
                    player.playSound('use.wood');
                }
            }
            if (selectedItem?.typeId === 'minecraft:water_bucket' && !block.permutation.getState('old_villagers_plus:waterlogged') && !block.permutation.getState('old_villagers_plus:double')) {
                player.playSound('bucket.empty_water');
                if (player.getGameMode() !== "creative") {
                    equipment.setEquipment('Mainhand', new ItemStack('minecraft:bucket', 1));
                }
                block.setPermutation(block.permutation.withState('old_villagers_plus:waterlogged', true));
                const verticalHalf = block.permutation.getState('minecraft:vertical_half');
                const slabType = block.typeId.split(':')[1];
                const structureName = (verticalHalf === 'bottom') ? `mystructure:${slabType}_bottomSlab` : `mystructure:${slabType}_topSlab`;
                const { x, y, z } = block;
                world.structureManager.place(structureName, e.dimension, { x, y, z });
            }
        }
    });
});

//Purple Slab
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_purple_slab', {
        onPlayerInteract(e) {
            const { block, player, face } = e;
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            if (selectedItem?.typeId === block.typeId && !block.permutation.getState('old_villagers_plus:double')) {
                const verticalHalf = block.permutation.getState('minecraft:vertical_half');
                const isBottomUp = verticalHalf === 'bottom' && face === 'Up';
                const isTopDown = verticalHalf === 'top' && face === 'Down';
                if (isBottomUp || isTopDown) {
                    if (player.getGameMode() !== "creative") {
                        if (selectedItem.amount > 1) {
                            selectedItem.amount -= 1;
                            equipment.setEquipment('Mainhand', selectedItem);
                        } else if (selectedItem.amount === 1) {
                            equipment.setEquipment('Mainhand', undefined); // Clear the slot if only 1 item left
                        }
                    }
                    block.setPermutation(block.permutation.withState('old_villagers_plus:double', true));
                    block.setWaterlogged(false);
                    player.playSound('use.wood');
                }
            }
            if (selectedItem?.typeId === 'minecraft:water_bucket' && !block.permutation.getState('old_villagers_plus:waterlogged') && !block.permutation.getState('old_villagers_plus:double')) {
                player.playSound('bucket.empty_water');
                if (player.getGameMode() !== "creative") {
                    equipment.setEquipment('Mainhand', new ItemStack('minecraft:bucket', 1));
                }
                block.setPermutation(block.permutation.withState('old_villagers_plus:waterlogged', true));
                const verticalHalf = block.permutation.getState('minecraft:vertical_half');
                const slabType = block.typeId.split(':')[1];
                const structureName = (verticalHalf === 'bottom') ? `mystructure:${slabType}_bottomSlab` : `mystructure:${slabType}_topSlab`;
                const { x, y, z } = block;
                world.structureManager.place(structureName, e.dimension, { x, y, z });
            }
        }
    });
});

//Red Slab
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_red_slab', {
        onPlayerInteract(e) {
            const { block, player, face } = e;
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            if (selectedItem?.typeId === block.typeId && !block.permutation.getState('old_villagers_plus:double')) {
                const verticalHalf = block.permutation.getState('minecraft:vertical_half');
                const isBottomUp = verticalHalf === 'bottom' && face === 'Up';
                const isTopDown = verticalHalf === 'top' && face === 'Down';
                if (isBottomUp || isTopDown) {
                    if (player.getGameMode() !== "creative") {
                        if (selectedItem.amount > 1) {
                            selectedItem.amount -= 1;
                            equipment.setEquipment('Mainhand', selectedItem);
                        } else if (selectedItem.amount === 1) {
                            equipment.setEquipment('Mainhand', undefined); // Clear the slot if only 1 item left
                        }
                    }
                    block.setPermutation(block.permutation.withState('old_villagers_plus:double', true));
                    block.setWaterlogged(false);
                    player.playSound('use.wood');
                }
            }
            if (selectedItem?.typeId === 'minecraft:water_bucket' && !block.permutation.getState('old_villagers_plus:waterlogged') && !block.permutation.getState('old_villagers_plus:double')) {
                player.playSound('bucket.empty_water');
                if (player.getGameMode() !== "creative") {
                    equipment.setEquipment('Mainhand', new ItemStack('minecraft:bucket', 1));
                }
                block.setPermutation(block.permutation.withState('old_villagers_plus:waterlogged', true));
                const verticalHalf = block.permutation.getState('minecraft:vertical_half');
                const slabType = block.typeId.split(':')[1];
                const structureName = (verticalHalf === 'bottom') ? `mystructure:${slabType}_bottomSlab` : `mystructure:${slabType}_topSlab`;
                const { x, y, z } = block;
                world.structureManager.place(structureName, e.dimension, { x, y, z });
            }
        }
    });
});

//White Slab
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_white_slab', {
        onPlayerInteract(e) {
            const { block, player, face } = e;
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            if (selectedItem?.typeId === block.typeId && !block.permutation.getState('old_villagers_plus:double')) {
                const verticalHalf = block.permutation.getState('minecraft:vertical_half');
                const isBottomUp = verticalHalf === 'bottom' && face === 'Up';
                const isTopDown = verticalHalf === 'top' && face === 'Down';
                if (isBottomUp || isTopDown) {
                    if (player.getGameMode() !== "creative") {
                        if (selectedItem.amount > 1) {
                            selectedItem.amount -= 1;
                            equipment.setEquipment('Mainhand', selectedItem);
                        } else if (selectedItem.amount === 1) {
                            equipment.setEquipment('Mainhand', undefined); // Clear the slot if only 1 item left
                        }
                    }
                    block.setPermutation(block.permutation.withState('old_villagers_plus:double', true));
                    block.setWaterlogged(false);
                    player.playSound('use.wood');
                }
            }
            if (selectedItem?.typeId === 'minecraft:water_bucket' && !block.permutation.getState('old_villagers_plus:waterlogged') && !block.permutation.getState('old_villagers_plus:double')) {
                player.playSound('bucket.empty_water');
                if (player.getGameMode() !== "creative") {
                    equipment.setEquipment('Mainhand', new ItemStack('minecraft:bucket', 1));
                }
                block.setPermutation(block.permutation.withState('old_villagers_plus:waterlogged', true));
                const verticalHalf = block.permutation.getState('minecraft:vertical_half');
                const slabType = block.typeId.split(':')[1];
                const structureName = (verticalHalf === 'bottom') ? `mystructure:${slabType}_bottomSlab` : `mystructure:${slabType}_topSlab`;
                const { x, y, z } = block;
                world.structureManager.place(structureName, e.dimension, { x, y, z });
            }
        }
    });
});

//Yellow Slab
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_yellow_slab', {
        onPlayerInteract(e) {
            const { block, player, face } = e;
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            if (selectedItem?.typeId === block.typeId && !block.permutation.getState('old_villagers_plus:double')) {
                const verticalHalf = block.permutation.getState('minecraft:vertical_half');
                const isBottomUp = verticalHalf === 'bottom' && face === 'Up';
                const isTopDown = verticalHalf === 'top' && face === 'Down';
                if (isBottomUp || isTopDown) {
                    if (player.getGameMode() !== "creative") {
                        if (selectedItem.amount > 1) {
                            selectedItem.amount -= 1;
                            equipment.setEquipment('Mainhand', selectedItem);
                        } else if (selectedItem.amount === 1) {
                            equipment.setEquipment('Mainhand', undefined); // Clear the slot if only 1 item left
                        }
                    }
                    block.setPermutation(block.permutation.withState('old_villagers_plus:double', true));
                    block.setWaterlogged(false);
                    player.playSound('use.wood');
                }
            }
            if (selectedItem?.typeId === 'minecraft:water_bucket' && !block.permutation.getState('old_villagers_plus:waterlogged') && !block.permutation.getState('old_villagers_plus:double')) {
                player.playSound('bucket.empty_water');
                if (player.getGameMode() !== "creative") {
                    equipment.setEquipment('Mainhand', new ItemStack('minecraft:bucket', 1));
                }
                block.setPermutation(block.permutation.withState('old_villagers_plus:waterlogged', true));
                const verticalHalf = block.permutation.getState('minecraft:vertical_half');
                const slabType = block.typeId.split(':')[1];
                const structureName = (verticalHalf === 'bottom') ? `mystructure:${slabType}_bottomSlab` : `mystructure:${slabType}_topSlab`;
                const { x, y, z } = block;
                world.structureManager.place(structureName, e.dimension, { x, y, z });
            }
        }
    });
});

//TRAPDOORS

//Black Trapdoor
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_black_trapdoor', {
        onPlayerInteract(e) {
            const { block, player } = e;
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            const currentState = block.permutation.getState('old_villagers_plus:open');
            const newOpenState = !currentState;
            const newPermutation = BlockPermutation.resolve(block.typeId, {
                ...block.permutation.getAllStates(),
                'old_villagers_plus:open': newOpenState
            });
            block.setPermutation(newPermutation);
            const sound = currentState ? 'open.wooden_trapdoor' : 'close.wooden_trapdoor';
            player.playSound(sound);
            if (selectedItem?.typeId === 'minecraft:water_bucket') {
                player.playSound('bucket.empty_water');
                if (player.getGameMode() !== "creative") {
                    equipment.setEquipment('Mainhand', new ItemStack('minecraft:bucket', 1));
                }
            }
            if (block.typeId === 'old_villagers_plus:black_trapdoor' && selectedItem?.typeId === 'minecraft:water_bucket') {
                const currentStates = block.permutation.getAllStates();
                const structureName = 'mystructure:trapdoor';
                const { x, y, z } = block.location;
                world.structureManager.place(structureName, e.dimension, { x, y, z });
                const newBlock = e.dimension.getBlock({ x, y, z });
                const newStates = { ...newBlock.permutation.getAllStates(), ...currentStates };
                const newPermutation = BlockPermutation.resolve(newBlock.typeId, newStates);
                newBlock.setPermutation(newPermutation);
            }
        }
    });
});

//Blue Trapdoor
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_blue_trapdoor', {
        onPlayerInteract(e) {
            const { block, player } = e;
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            const currentState = block.permutation.getState('old_villagers_plus:open');
            const newOpenState = !currentState;
            const newPermutation = BlockPermutation.resolve(block.typeId, {
                ...block.permutation.getAllStates(),
                'old_villagers_plus:open': newOpenState
            });
            block.setPermutation(newPermutation);
            const sound = currentState ? 'open.wooden_trapdoor' : 'close.wooden_trapdoor';
            player.playSound(sound);
            if (selectedItem?.typeId === 'minecraft:water_bucket') {
                player.playSound('bucket.empty_water');
                if (player.getGameMode() !== "creative") {
                    equipment.setEquipment('Mainhand', new ItemStack('minecraft:bucket', 1));
                }
            }
            if (block.typeId === 'old_villagers_plus:blue_trapdoor' && selectedItem?.typeId === 'minecraft:water_bucket') {
                const currentStates = block.permutation.getAllStates();
                const structureName = 'mystructure:trapdoor';
                const { x, y, z } = block.location;
                world.structureManager.place(structureName, e.dimension, { x, y, z });
                const newBlock = e.dimension.getBlock({ x, y, z });
                const newStates = { ...newBlock.permutation.getAllStates(), ...currentStates };
                const newPermutation = BlockPermutation.resolve(newBlock.typeId, newStates);
                newBlock.setPermutation(newPermutation);
            }
        }
    });
});

//Brown Trapdoor
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_brown_trapdoor', {
        onPlayerInteract(e) {
            const { block, player } = e;
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            const currentState = block.permutation.getState('old_villagers_plus:open');
            const newOpenState = !currentState;
            const newPermutation = BlockPermutation.resolve(block.typeId, {
                ...block.permutation.getAllStates(),
                'old_villagers_plus:open': newOpenState
            });
            block.setPermutation(newPermutation);
            const sound = currentState ? 'open.wooden_trapdoor' : 'close.wooden_trapdoor';
            player.playSound(sound);
            if (selectedItem?.typeId === 'minecraft:water_bucket') {
                player.playSound('bucket.empty_water');
                if (player.getGameMode() !== "creative") {
                    equipment.setEquipment('Mainhand', new ItemStack('minecraft:bucket', 1));
                }
            }
            if (block.typeId === 'old_villagers_plus:brown_trapdoor' && selectedItem?.typeId === 'minecraft:water_bucket') {
                const currentStates = block.permutation.getAllStates();
                const structureName = 'mystructure:trapdoor';
                const { x, y, z } = block.location;
                world.structureManager.place(structureName, e.dimension, { x, y, z });
                const newBlock = e.dimension.getBlock({ x, y, z });
                const newStates = { ...newBlock.permutation.getAllStates(), ...currentStates };
                const newPermutation = BlockPermutation.resolve(newBlock.typeId, newStates);
                newBlock.setPermutation(newPermutation);
            }
        }
    });
});

//Cyan Trapdoor
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_cyan_trapdoor', {
        onPlayerInteract(e) {
            const { block, player } = e;
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            const currentState = block.permutation.getState('old_villagers_plus:open');
            const newOpenState = !currentState;
            const newPermutation = BlockPermutation.resolve(block.typeId, {
                ...block.permutation.getAllStates(),
                'old_villagers_plus:open': newOpenState
            });
            block.setPermutation(newPermutation);
            const sound = currentState ? 'open.wooden_trapdoor' : 'close.wooden_trapdoor';
            player.playSound(sound);
            if (selectedItem?.typeId === 'minecraft:water_bucket') {
                player.playSound('bucket.empty_water');
                if (player.getGameMode() !== "creative") {
                    equipment.setEquipment('Mainhand', new ItemStack('minecraft:bucket', 1));
                }
            }
            if (block.typeId === 'old_villagers_plus:cyan_trapdoor' && selectedItem?.typeId === 'minecraft:water_bucket') {
                const currentStates = block.permutation.getAllStates();
                const structureName = 'mystructure:trapdoor';
                const { x, y, z } = block.location;
                world.structureManager.place(structureName, e.dimension, { x, y, z });
                const newBlock = e.dimension.getBlock({ x, y, z });
                const newStates = { ...newBlock.permutation.getAllStates(), ...currentStates };
                const newPermutation = BlockPermutation.resolve(newBlock.typeId, newStates);
                newBlock.setPermutation(newPermutation);
            }
        }
    });
});

//Dark Green Trapdoor
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_dark_green_trapdoor', {
        onPlayerInteract(e) {
            const { block, player } = e;
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            const currentState = block.permutation.getState('old_villagers_plus:open');
            const newOpenState = !currentState;
            const newPermutation = BlockPermutation.resolve(block.typeId, {
                ...block.permutation.getAllStates(),
                'old_villagers_plus:open': newOpenState
            });
            block.setPermutation(newPermutation);
            const sound = currentState ? 'open.wooden_trapdoor' : 'close.wooden_trapdoor';
            player.playSound(sound);
            if (selectedItem?.typeId === 'minecraft:water_bucket') {
                player.playSound('bucket.empty_water');
                if (player.getGameMode() !== "creative") {
                    equipment.setEquipment('Mainhand', new ItemStack('minecraft:bucket', 1));
                }
            }
            if (block.typeId === 'old_villagers_plus:dark_green_trapdoor' && selectedItem?.typeId === 'minecraft:water_bucket') {
                const currentStates = block.permutation.getAllStates();
                const structureName = 'mystructure:trapdoor';
                const { x, y, z } = block.location;
                world.structureManager.place(structureName, e.dimension, { x, y, z });
                const newBlock = e.dimension.getBlock({ x, y, z });
                const newStates = { ...newBlock.permutation.getAllStates(), ...currentStates };
                const newPermutation = BlockPermutation.resolve(newBlock.typeId, newStates);
                newBlock.setPermutation(newPermutation);
            }
        }
    });
});

//Dark Purple Trapdoor
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_dark_purple_trapdoor', {
        onPlayerInteract(e) {
            const { block, player } = e;
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            const currentState = block.permutation.getState('old_villagers_plus:open');
            const newOpenState = !currentState;
            const newPermutation = BlockPermutation.resolve(block.typeId, {
                ...block.permutation.getAllStates(),
                'old_villagers_plus:open': newOpenState
            });
            block.setPermutation(newPermutation);
            const sound = currentState ? 'open.wooden_trapdoor' : 'close.wooden_trapdoor';
            player.playSound(sound);
            if (selectedItem?.typeId === 'minecraft:water_bucket') {
                player.playSound('bucket.empty_water');
                if (player.getGameMode() !== "creative") {
                    equipment.setEquipment('Mainhand', new ItemStack('minecraft:bucket', 1));
                }
            }
            if (block.typeId === 'old_villagers_plus:dark_purple_trapdoor' && selectedItem?.typeId === 'minecraft:water_bucket') {
                const currentStates = block.permutation.getAllStates();
                const structureName = 'mystructure:trapdoor';
                const { x, y, z } = block.location;
                world.structureManager.place(structureName, e.dimension, { x, y, z });
                const newBlock = e.dimension.getBlock({ x, y, z });
                const newStates = { ...newBlock.permutation.getAllStates(), ...currentStates };
                const newPermutation = BlockPermutation.resolve(newBlock.typeId, newStates);
                newBlock.setPermutation(newPermutation);
            }
        }
    });
});

//Green Trapdoor
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_green_trapdoor', {
        onPlayerInteract(e) {
            const { block, player } = e;
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            const currentState = block.permutation.getState('old_villagers_plus:open');
            const newOpenState = !currentState;
            const newPermutation = BlockPermutation.resolve(block.typeId, {
                ...block.permutation.getAllStates(),
                'old_villagers_plus:open': newOpenState
            });
            block.setPermutation(newPermutation);
            const sound = currentState ? 'open.wooden_trapdoor' : 'close.wooden_trapdoor';
            player.playSound(sound);
            if (selectedItem?.typeId === 'minecraft:water_bucket') {
                player.playSound('bucket.empty_water');
                if (player.getGameMode() !== "creative") {
                    equipment.setEquipment('Mainhand', new ItemStack('minecraft:bucket', 1));
                }
            }
            if (block.typeId === 'old_villagers_plus:green_trapdoor' && selectedItem?.typeId === 'minecraft:water_bucket') {
                const currentStates = block.permutation.getAllStates();
                const structureName = 'mystructure:trapdoor';
                const { x, y, z } = block.location;
                world.structureManager.place(structureName, e.dimension, { x, y, z });
                const newBlock = e.dimension.getBlock({ x, y, z });
                const newStates = { ...newBlock.permutation.getAllStates(), ...currentStates };
                const newPermutation = BlockPermutation.resolve(newBlock.typeId, newStates);
                newBlock.setPermutation(newPermutation);
            }
        }
    });
});

//Grey Trapdoor
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_grey_trapdoor', {
        onPlayerInteract(e) {
            const { block, player } = e;
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            const currentState = block.permutation.getState('old_villagers_plus:open');
            const newOpenState = !currentState;
            const newPermutation = BlockPermutation.resolve(block.typeId, {
                ...block.permutation.getAllStates(),
                'old_villagers_plus:open': newOpenState
            });
            block.setPermutation(newPermutation);
            const sound = currentState ? 'open.wooden_trapdoor' : 'close.wooden_trapdoor';
            player.playSound(sound);
            if (selectedItem?.typeId === 'minecraft:water_bucket') {
                player.playSound('bucket.empty_water');
                if (player.getGameMode() !== "creative") {
                    equipment.setEquipment('Mainhand', new ItemStack('minecraft:bucket', 1));
                }
            }
            if (block.typeId === 'old_villagers_plus:grey_trapdoor' && selectedItem?.typeId === 'minecraft:water_bucket') {
                const currentStates = block.permutation.getAllStates();
                const structureName = 'mystructure:trapdoor';
                const { x, y, z } = block.location;
                world.structureManager.place(structureName, e.dimension, { x, y, z });
                const newBlock = e.dimension.getBlock({ x, y, z });
                const newStates = { ...newBlock.permutation.getAllStates(), ...currentStates };
                const newPermutation = BlockPermutation.resolve(newBlock.typeId, newStates);
                newBlock.setPermutation(newPermutation);
            }
        }
    });
});

//Light Blue Trapdoor
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_light_blue_trapdoor', {
        onPlayerInteract(e) {
            const { block, player } = e;
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            const currentState = block.permutation.getState('old_villagers_plus:open');
            const newOpenState = !currentState;
            const newPermutation = BlockPermutation.resolve(block.typeId, {
                ...block.permutation.getAllStates(),
                'old_villagers_plus:open': newOpenState
            });
            block.setPermutation(newPermutation);
            const sound = currentState ? 'open.wooden_trapdoor' : 'close.wooden_trapdoor';
            player.playSound(sound);
            if (selectedItem?.typeId === 'minecraft:water_bucket') {
                player.playSound('bucket.empty_water');
                if (player.getGameMode() !== "creative") {
                    equipment.setEquipment('Mainhand', new ItemStack('minecraft:bucket', 1));
                }
            }
            if (block.typeId === 'old_villagers_plus:light_blue_trapdoor' && selectedItem?.typeId === 'minecraft:water_bucket') {
                const currentStates = block.permutation.getAllStates();
                const structureName = 'mystructure:trapdoor';
                const { x, y, z } = block.location;
                world.structureManager.place(structureName, e.dimension, { x, y, z });
                const newBlock = e.dimension.getBlock({ x, y, z });
                const newStates = { ...newBlock.permutation.getAllStates(), ...currentStates };
                const newPermutation = BlockPermutation.resolve(newBlock.typeId, newStates);
                newBlock.setPermutation(newPermutation);
            }
        }
    });
});

//Light Grey Trapdoor
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_light_grey_trapdoor', {
        onPlayerInteract(e) {
            const { block, player } = e;
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            const currentState = block.permutation.getState('old_villagers_plus:open');
            const newOpenState = !currentState;
            const newPermutation = BlockPermutation.resolve(block.typeId, {
                ...block.permutation.getAllStates(),
                'old_villagers_plus:open': newOpenState
            });
            block.setPermutation(newPermutation);
            const sound = currentState ? 'open.wooden_trapdoor' : 'close.wooden_trapdoor';
            player.playSound(sound);
            if (selectedItem?.typeId === 'minecraft:water_bucket') {
                player.playSound('bucket.empty_water');
                if (player.getGameMode() !== "creative") {
                    equipment.setEquipment('Mainhand', new ItemStack('minecraft:bucket', 1));
                }
            }
            if (block.typeId === 'old_villagers_plus:light_grey_trapdoor' && selectedItem?.typeId === 'minecraft:water_bucket') {
                const currentStates = block.permutation.getAllStates();
                const structureName = 'mystructure:trapdoor';
                const { x, y, z } = block.location;
                world.structureManager.place(structureName, e.dimension, { x, y, z });
                const newBlock = e.dimension.getBlock({ x, y, z });
                const newStates = { ...newBlock.permutation.getAllStates(), ...currentStates };
                const newPermutation = BlockPermutation.resolve(newBlock.typeId, newStates);
                newBlock.setPermutation(newPermutation);
            }
        }
    });
});

//Orange Trapdoor
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_orange_trapdoor', {
        onPlayerInteract(e) {
            const { block, player } = e;
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            const currentState = block.permutation.getState('old_villagers_plus:open');
            const newOpenState = !currentState;
            const newPermutation = BlockPermutation.resolve(block.typeId, {
                ...block.permutation.getAllStates(),
                'old_villagers_plus:open': newOpenState
            });
            block.setPermutation(newPermutation);
            const sound = currentState ? 'open.wooden_trapdoor' : 'close.wooden_trapdoor';
            player.playSound(sound);
            if (selectedItem?.typeId === 'minecraft:water_bucket') {
                player.playSound('bucket.empty_water');
                if (player.getGameMode() !== "creative") {
                    equipment.setEquipment('Mainhand', new ItemStack('minecraft:bucket', 1));
                }
            }
            if (block.typeId === 'old_villagers_plus:orange_trapdoor' && selectedItem?.typeId === 'minecraft:water_bucket') {
                const currentStates = block.permutation.getAllStates();
                const structureName = 'mystructure:trapdoor';
                const { x, y, z } = block.location;
                world.structureManager.place(structureName, e.dimension, { x, y, z });
                const newBlock = e.dimension.getBlock({ x, y, z });
                const newStates = { ...newBlock.permutation.getAllStates(), ...currentStates };
                const newPermutation = BlockPermutation.resolve(newBlock.typeId, newStates);
                newBlock.setPermutation(newPermutation);
            }
        }
    });
});

//Pink Trapdoor
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_pink_trapdoor', {
        onPlayerInteract(e) {
            const { block, player } = e;
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            const currentState = block.permutation.getState('old_villagers_plus:open');
            const newOpenState = !currentState;
            const newPermutation = BlockPermutation.resolve(block.typeId, {
                ...block.permutation.getAllStates(),
                'old_villagers_plus:open': newOpenState
            });
            block.setPermutation(newPermutation);
            const sound = currentState ? 'open.wooden_trapdoor' : 'close.wooden_trapdoor';
            player.playSound(sound);
            if (selectedItem?.typeId === 'minecraft:water_bucket') {
                player.playSound('bucket.empty_water');
                if (player.getGameMode() !== "creative") {
                    equipment.setEquipment('Mainhand', new ItemStack('minecraft:bucket', 1));
                }
            }
            if (block.typeId === 'old_villagers_plus:pink_trapdoor' && selectedItem?.typeId === 'minecraft:water_bucket') {
                const currentStates = block.permutation.getAllStates();
                const structureName = 'mystructure:trapdoor';
                const { x, y, z } = block.location;
                world.structureManager.place(structureName, e.dimension, { x, y, z });
                const newBlock = e.dimension.getBlock({ x, y, z });
                const newStates = { ...newBlock.permutation.getAllStates(), ...currentStates };
                const newPermutation = BlockPermutation.resolve(newBlock.typeId, newStates);
                newBlock.setPermutation(newPermutation);
            }
        }
    });
});

//Purple Trapdoor
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_purple_trapdoor', {
        onPlayerInteract(e) {
            const { block, player } = e;
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            const currentState = block.permutation.getState('old_villagers_plus:open');
            const newOpenState = !currentState;
            const newPermutation = BlockPermutation.resolve(block.typeId, {
                ...block.permutation.getAllStates(),
                'old_villagers_plus:open': newOpenState
            });
            block.setPermutation(newPermutation);
            const sound = currentState ? 'open.wooden_trapdoor' : 'close.wooden_trapdoor';
            player.playSound(sound);
            if (selectedItem?.typeId === 'minecraft:water_bucket') {
                player.playSound('bucket.empty_water');
                if (player.getGameMode() !== "creative") {
                    equipment.setEquipment('Mainhand', new ItemStack('minecraft:bucket', 1));
                }
            }
            if (block.typeId === 'old_villagers_plus:purple_trapdoor' && selectedItem?.typeId === 'minecraft:water_bucket') {
                const currentStates = block.permutation.getAllStates();
                const structureName = 'mystructure:trapdoor';
                const { x, y, z } = block.location;
                world.structureManager.place(structureName, e.dimension, { x, y, z });
                const newBlock = e.dimension.getBlock({ x, y, z });
                const newStates = { ...newBlock.permutation.getAllStates(), ...currentStates };
                const newPermutation = BlockPermutation.resolve(newBlock.typeId, newStates);
                newBlock.setPermutation(newPermutation);
            }
        }
    });
});

//Red Trapdoor
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_red_trapdoor', {
        onPlayerInteract(e) {
            const { block, player } = e;
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            const currentState = block.permutation.getState('old_villagers_plus:open');
            const newOpenState = !currentState;
            const newPermutation = BlockPermutation.resolve(block.typeId, {
                ...block.permutation.getAllStates(),
                'old_villagers_plus:open': newOpenState
            });
            block.setPermutation(newPermutation);
            const sound = currentState ? 'open.wooden_trapdoor' : 'close.wooden_trapdoor';
            player.playSound(sound);
            if (selectedItem?.typeId === 'minecraft:water_bucket') {
                player.playSound('bucket.empty_water');
                if (player.getGameMode() !== "creative") {
                    equipment.setEquipment('Mainhand', new ItemStack('minecraft:bucket', 1));
                }
            }
            if (block.typeId === 'old_villagers_plus:red_trapdoor' && selectedItem?.typeId === 'minecraft:water_bucket') {
                const currentStates = block.permutation.getAllStates();
                const structureName = 'mystructure:trapdoor';
                const { x, y, z } = block.location;
                world.structureManager.place(structureName, e.dimension, { x, y, z });
                const newBlock = e.dimension.getBlock({ x, y, z });
                const newStates = { ...newBlock.permutation.getAllStates(), ...currentStates };
                const newPermutation = BlockPermutation.resolve(newBlock.typeId, newStates);
                newBlock.setPermutation(newPermutation);
            }
        }
    });
});

//White Trapdoor
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_white_trapdoor', {
        onPlayerInteract(e) {
            const { block, player } = e;
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            const currentState = block.permutation.getState('old_villagers_plus:open');
            const newOpenState = !currentState;
            const newPermutation = BlockPermutation.resolve(block.typeId, {
                ...block.permutation.getAllStates(),
                'old_villagers_plus:open': newOpenState
            });
            block.setPermutation(newPermutation);
            const sound = currentState ? 'open.wooden_trapdoor' : 'close.wooden_trapdoor';
            player.playSound(sound);
            if (selectedItem?.typeId === 'minecraft:water_bucket') {
                player.playSound('bucket.empty_water');
                if (player.getGameMode() !== "creative") {
                    equipment.setEquipment('Mainhand', new ItemStack('minecraft:bucket', 1));
                }
            }
            if (block.typeId === 'old_villagers_plus:white_trapdoor' && selectedItem?.typeId === 'minecraft:water_bucket') {
                const currentStates = block.permutation.getAllStates();
                const structureName = 'mystructure:trapdoor';
                const { x, y, z } = block.location;
                world.structureManager.place(structureName, e.dimension, { x, y, z });
                const newBlock = e.dimension.getBlock({ x, y, z });
                const newStates = { ...newBlock.permutation.getAllStates(), ...currentStates };
                const newPermutation = BlockPermutation.resolve(newBlock.typeId, newStates);
                newBlock.setPermutation(newPermutation);
            }
        }
    });
});

//Yellow Trapdoor
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_yellow_trapdoor', {
        onPlayerInteract(e) {
            const { block, player } = e;
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            const currentState = block.permutation.getState('old_villagers_plus:open');
            const newOpenState = !currentState;
            const newPermutation = BlockPermutation.resolve(block.typeId, {
                ...block.permutation.getAllStates(),
                'old_villagers_plus:open': newOpenState
            });
            block.setPermutation(newPermutation);
            const sound = currentState ? 'open.wooden_trapdoor' : 'close.wooden_trapdoor';
            player.playSound(sound);
            if (selectedItem?.typeId === 'minecraft:water_bucket') {
                player.playSound('bucket.empty_water');
                if (player.getGameMode() !== "creative") {
                    equipment.setEquipment('Mainhand', new ItemStack('minecraft:bucket', 1));
                }
            }
            if (block.typeId === 'old_villagers_plus:yellow_trapdoor' && selectedItem?.typeId === 'minecraft:water_bucket') {
                const currentStates = block.permutation.getAllStates();
                const structureName = 'mystructure:trapdoor';
                const { x, y, z } = block.location;
                world.structureManager.place(structureName, e.dimension, { x, y, z });
                const newBlock = e.dimension.getBlock({ x, y, z });
                const newStates = { ...newBlock.permutation.getAllStates(), ...currentStates };
                const newPermutation = BlockPermutation.resolve(newBlock.typeId, newStates);
                newBlock.setPermutation(newPermutation);
            }
        }
    });
});

//FENCE GATES

// Function to calculate the new cardinal direction based on the player's rotation
function getNewCardinalDirection(currentDirection, angle) {
    const direction = directionDisplay(angle);
    if (['north', 'south'].includes(currentDirection)) {
        return direction.includes('south') ? 'south' : 'north';
    } else {
        return direction.includes('west') ? 'west' : 'east';
    }
}

// Function to calculate the direction a player is looking at
function directionDisplay(angle) {
    if (Math.abs(angle) > 112.5) return 'north';
    if (Math.abs(angle) < 67.5) return 'south';
    if (angle < 157.5 && angle > 22.5) return 'west';
    if (angle > -157.5 && angle < -22.5) return 'east';
    return '';
}

//Black Fence Gate
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_black_fence_gate', {
        onPlayerInteract(e) {
            const { block, player, face } = e;
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            if (selectedItem && face === 'Up' && BlockTypes.get(selectedItem.typeId)) {
                const aboveBlock = block.above();
                if (aboveBlock.typeId === 'old_villagers_plus:black_fence_gate') {
                    aboveBlock.setType(selectedItem.typeId);
                    if (player.getGameMode() !== "creative") {
                        if (selectedItem.amount > 1) {
                            selectedItem.amount -= 1;
                            equipment.setEquipment('Mainhand', selectedItem);
                        } else {
                            equipment.setEquipment('Mainhand', undefined); // Clear the slot if only 1 item left
                        }
                    }
                    return; // Exit the function after placing the block
                }
            }
            const currentState = block.permutation.getState('old_villagers_plus:open');
            const newOpenState = !currentState;
            const sound = newOpenState ? 'open.fence_gate' : 'close.fence_gate';
            const rotationAngle = player.getRotation().y;
            const newCardinalDirection = getNewCardinalDirection(block.permutation.getState('minecraft:cardinal_direction'), rotationAngle);
            const newPermutation = BlockPermutation.resolve(block.typeId, {
                ...block.permutation.getAllStates(),
                'old_villagers_plus:open': newOpenState,
                'minecraft:cardinal_direction': newCardinalDirection
            });
            block.setPermutation(newPermutation);
            block.dimension.playSound(sound, block.location);
            const aboveBlock = block.above();
            if (aboveBlock.typeId === 'old_villagers_plus:black_fence_gate' && aboveBlock.permutation.getState('old_villagers_plus:invisible')) {
                const aboveCurrentState = aboveBlock.permutation.getState('old_villagers_plus:open');
                if (aboveCurrentState !== newOpenState) {
                    const newAbovePermutation = BlockPermutation.resolve(aboveBlock.typeId, {
                        ...aboveBlock.permutation.getAllStates(),
                        'old_villagers_plus:open': newOpenState
                    });
                    aboveBlock.setPermutation(newAbovePermutation);
                }
            }
        }
    });
});

//Blue Fence Gate
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_blue_fence_gate', {
        onPlayerInteract(e) {
            const { block, player, face } = e;
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            if (selectedItem && face === 'Up' && BlockTypes.get(selectedItem.typeId)) {
                const aboveBlock = block.above();
                if (aboveBlock.typeId === 'old_villagers_plus:blue_fence_gate') {
                    aboveBlock.setType(selectedItem.typeId);
                    if (player.getGameMode() !== "creative") {
                        if (selectedItem.amount > 1) {
                            selectedItem.amount -= 1;
                            equipment.setEquipment('Mainhand', selectedItem);
                        } else {
                            equipment.setEquipment('Mainhand', undefined); // Clear the slot if only 1 item left
                        }
                    }
                    return; // Exit the function after placing the block
                }
            }
            const currentState = block.permutation.getState('old_villagers_plus:open');
            const newOpenState = !currentState;
            const sound = newOpenState ? 'open.fence_gate' : 'close.fence_gate';
            const rotationAngle = player.getRotation().y;
            const newCardinalDirection = getNewCardinalDirection(block.permutation.getState('minecraft:cardinal_direction'), rotationAngle);
            const newPermutation = BlockPermutation.resolve(block.typeId, {
                ...block.permutation.getAllStates(),
                'old_villagers_plus:open': newOpenState,
                'minecraft:cardinal_direction': newCardinalDirection
            });
            block.setPermutation(newPermutation);
            block.dimension.playSound(sound, block.location);
            const aboveBlock = block.above();
            if (aboveBlock.typeId === 'old_villagers_plus:blue_fence_gate' && aboveBlock.permutation.getState('old_villagers_plus:invisible')) {
                const aboveCurrentState = aboveBlock.permutation.getState('old_villagers_plus:open');
                if (aboveCurrentState !== newOpenState) {
                    const newAbovePermutation = BlockPermutation.resolve(aboveBlock.typeId, {
                        ...aboveBlock.permutation.getAllStates(),
                        'old_villagers_plus:open': newOpenState
                    });
                    aboveBlock.setPermutation(newAbovePermutation);
                }
            }
        }
    });
});

//Brown Fence Gate
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_brown_fence_gate', {
        onPlayerInteract(e) {
            const { block, player, face } = e;
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            if (selectedItem && face === 'Up' && BlockTypes.get(selectedItem.typeId)) {
                const aboveBlock = block.above();
                if (aboveBlock.typeId === 'old_villagers_plus:brown_fence_gate') {
                    aboveBlock.setType(selectedItem.typeId);
                    if (player.getGameMode() !== "creative") {
                        if (selectedItem.amount > 1) {
                            selectedItem.amount -= 1;
                            equipment.setEquipment('Mainhand', selectedItem);
                        } else {
                            equipment.setEquipment('Mainhand', undefined); // Clear the slot if only 1 item left
                        }
                    }
                    return; // Exit the function after placing the block
                }
            }
            const currentState = block.permutation.getState('old_villagers_plus:open');
            const newOpenState = !currentState;
            const sound = newOpenState ? 'open.fence_gate' : 'close.fence_gate';
            const rotationAngle = player.getRotation().y;
            const newCardinalDirection = getNewCardinalDirection(block.permutation.getState('minecraft:cardinal_direction'), rotationAngle);
            const newPermutation = BlockPermutation.resolve(block.typeId, {
                ...block.permutation.getAllStates(),
                'old_villagers_plus:open': newOpenState,
                'minecraft:cardinal_direction': newCardinalDirection
            });
            block.setPermutation(newPermutation);
            block.dimension.playSound(sound, block.location);
            const aboveBlock = block.above();
            if (aboveBlock.typeId === 'old_villagers_plus:brown_fence_gate' && aboveBlock.permutation.getState('old_villagers_plus:invisible')) {
                const aboveCurrentState = aboveBlock.permutation.getState('old_villagers_plus:open');
                if (aboveCurrentState !== newOpenState) {
                    const newAbovePermutation = BlockPermutation.resolve(aboveBlock.typeId, {
                        ...aboveBlock.permutation.getAllStates(),
                        'old_villagers_plus:open': newOpenState
                    });
                    aboveBlock.setPermutation(newAbovePermutation);
                }
            }
        }
    });
});

//Cyan Fence Gate
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_cyan_fence_gate', {
        onPlayerInteract(e) {
            const { block, player, face } = e;
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            if (selectedItem && face === 'Up' && BlockTypes.get(selectedItem.typeId)) {
                const aboveBlock = block.above();
                if (aboveBlock.typeId === 'old_villagers_plus:cyan_fence_gate') {
                    aboveBlock.setType(selectedItem.typeId);
                    if (player.getGameMode() !== "creative") {
                        if (selectedItem.amount > 1) {
                            selectedItem.amount -= 1;
                            equipment.setEquipment('Mainhand', selectedItem);
                        } else {
                            equipment.setEquipment('Mainhand', undefined); // Clear the slot if only 1 item left
                        }
                    }
                    return; // Exit the function after placing the block
                }
            }
            const currentState = block.permutation.getState('old_villagers_plus:open');
            const newOpenState = !currentState;
            const sound = newOpenState ? 'open.fence_gate' : 'close.fence_gate';
            const rotationAngle = player.getRotation().y;
            const newCardinalDirection = getNewCardinalDirection(block.permutation.getState('minecraft:cardinal_direction'), rotationAngle);
            const newPermutation = BlockPermutation.resolve(block.typeId, {
                ...block.permutation.getAllStates(),
                'old_villagers_plus:open': newOpenState,
                'minecraft:cardinal_direction': newCardinalDirection
            });
            block.setPermutation(newPermutation);
            block.dimension.playSound(sound, block.location);
            const aboveBlock = block.above();
            if (aboveBlock.typeId === 'old_villagers_plus:cyan_fence_gate' && aboveBlock.permutation.getState('old_villagers_plus:invisible')) {
                const aboveCurrentState = aboveBlock.permutation.getState('old_villagers_plus:open');
                if (aboveCurrentState !== newOpenState) {
                    const newAbovePermutation = BlockPermutation.resolve(aboveBlock.typeId, {
                        ...aboveBlock.permutation.getAllStates(),
                        'old_villagers_plus:open': newOpenState
                    });
                    aboveBlock.setPermutation(newAbovePermutation);
                }
            }
        }
    });
});

//Dark Green Fence Gate
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_dark_green_fence_gate', {
        onPlayerInteract(e) {
            const { block, player, face } = e;
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            if (selectedItem && face === 'Up' && BlockTypes.get(selectedItem.typeId)) {
                const aboveBlock = block.above();
                if (aboveBlock.typeId === 'old_villagers_plus:dark_green_fence_gate') {
                    aboveBlock.setType(selectedItem.typeId);
                    if (player.getGameMode() !== "creative") {
                        if (selectedItem.amount > 1) {
                            selectedItem.amount -= 1;
                            equipment.setEquipment('Mainhand', selectedItem);
                        } else {
                            equipment.setEquipment('Mainhand', undefined); // Clear the slot if only 1 item left
                        }
                    }
                    return; // Exit the function after placing the block
                }
            }
            const currentState = block.permutation.getState('old_villagers_plus:open');
            const newOpenState = !currentState;
            const sound = newOpenState ? 'open.fence_gate' : 'close.fence_gate';
            const rotationAngle = player.getRotation().y;
            const newCardinalDirection = getNewCardinalDirection(block.permutation.getState('minecraft:cardinal_direction'), rotationAngle);
            const newPermutation = BlockPermutation.resolve(block.typeId, {
                ...block.permutation.getAllStates(),
                'old_villagers_plus:open': newOpenState,
                'minecraft:cardinal_direction': newCardinalDirection
            });
            block.setPermutation(newPermutation);
            block.dimension.playSound(sound, block.location);
            const aboveBlock = block.above();
            if (aboveBlock.typeId === 'old_villagers_plus:dark_green_fence_gate' && aboveBlock.permutation.getState('old_villagers_plus:invisible')) {
                const aboveCurrentState = aboveBlock.permutation.getState('old_villagers_plus:open');
                if (aboveCurrentState !== newOpenState) {
                    const newAbovePermutation = BlockPermutation.resolve(aboveBlock.typeId, {
                        ...aboveBlock.permutation.getAllStates(),
                        'old_villagers_plus:open': newOpenState
                    });
                    aboveBlock.setPermutation(newAbovePermutation);
                }
            }
        }
    });
});

//Dark Purple Fence Gate
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_dark_purple_fence_gate', {
        onPlayerInteract(e) {
            const { block, player, face } = e;
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            if (selectedItem && face === 'Up' && BlockTypes.get(selectedItem.typeId)) {
                const aboveBlock = block.above();
                if (aboveBlock.typeId === 'old_villagers_plus:dark_purple_fence_gate') {
                    aboveBlock.setType(selectedItem.typeId);
                    if (player.getGameMode() !== "creative") {
                        if (selectedItem.amount > 1) {
                            selectedItem.amount -= 1;
                            equipment.setEquipment('Mainhand', selectedItem);
                        } else {
                            equipment.setEquipment('Mainhand', undefined); // Clear the slot if only 1 item left
                        }
                    }
                    return; // Exit the function after placing the block
                }
            }
            const currentState = block.permutation.getState('old_villagers_plus:open');
            const newOpenState = !currentState;
            const sound = newOpenState ? 'open.fence_gate' : 'close.fence_gate';
            const rotationAngle = player.getRotation().y;
            const newCardinalDirection = getNewCardinalDirection(block.permutation.getState('minecraft:cardinal_direction'), rotationAngle);
            const newPermutation = BlockPermutation.resolve(block.typeId, {
                ...block.permutation.getAllStates(),
                'old_villagers_plus:open': newOpenState,
                'minecraft:cardinal_direction': newCardinalDirection
            });
            block.setPermutation(newPermutation);
            block.dimension.playSound(sound, block.location);
            const aboveBlock = block.above();
            if (aboveBlock.typeId === 'old_villagers_plus:dark_purple_fence_gate' && aboveBlock.permutation.getState('old_villagers_plus:invisible')) {
                const aboveCurrentState = aboveBlock.permutation.getState('old_villagers_plus:open');
                if (aboveCurrentState !== newOpenState) {
                    const newAbovePermutation = BlockPermutation.resolve(aboveBlock.typeId, {
                        ...aboveBlock.permutation.getAllStates(),
                        'old_villagers_plus:open': newOpenState
                    });
                    aboveBlock.setPermutation(newAbovePermutation);
                }
            }
        }
    });
});

//Green Fence Gate
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_green_fence_gate', {
        onPlayerInteract(e) {
            const { block, player, face } = e;
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            if (selectedItem && face === 'Up' && BlockTypes.get(selectedItem.typeId)) {
                const aboveBlock = block.above();
                if (aboveBlock.typeId === 'old_villagers_plus:green_fence_gate') {
                    aboveBlock.setType(selectedItem.typeId);
                    if (player.getGameMode() !== "creative") {
                        if (selectedItem.amount > 1) {
                            selectedItem.amount -= 1;
                            equipment.setEquipment('Mainhand', selectedItem);
                        } else {
                            equipment.setEquipment('Mainhand', undefined); // Clear the slot if only 1 item left
                        }
                    }
                    return; // Exit the function after placing the block
                }
            }
            const currentState = block.permutation.getState('old_villagers_plus:open');
            const newOpenState = !currentState;
            const sound = newOpenState ? 'open.fence_gate' : 'close.fence_gate';
            const rotationAngle = player.getRotation().y;
            const newCardinalDirection = getNewCardinalDirection(block.permutation.getState('minecraft:cardinal_direction'), rotationAngle);
            const newPermutation = BlockPermutation.resolve(block.typeId, {
                ...block.permutation.getAllStates(),
                'old_villagers_plus:open': newOpenState,
                'minecraft:cardinal_direction': newCardinalDirection
            });
            block.setPermutation(newPermutation);
            block.dimension.playSound(sound, block.location);
            const aboveBlock = block.above();
            if (aboveBlock.typeId === 'old_villagers_plus:green_fence_gate' && aboveBlock.permutation.getState('old_villagers_plus:invisible')) {
                const aboveCurrentState = aboveBlock.permutation.getState('old_villagers_plus:open');
                if (aboveCurrentState !== newOpenState) {
                    const newAbovePermutation = BlockPermutation.resolve(aboveBlock.typeId, {
                        ...aboveBlock.permutation.getAllStates(),
                        'old_villagers_plus:open': newOpenState
                    });
                    aboveBlock.setPermutation(newAbovePermutation);
                }
            }
        }
    });
});

//Grey Fence Gate
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_grey_fence_gate', {
        onPlayerInteract(e) {
            const { block, player, face } = e;
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            if (selectedItem && face === 'Up' && BlockTypes.get(selectedItem.typeId)) {
                const aboveBlock = block.above();
                if (aboveBlock.typeId === 'old_villagers_plus:grey_fence_gate') {
                    aboveBlock.setType(selectedItem.typeId);
                    if (player.getGameMode() !== "creative") {
                        if (selectedItem.amount > 1) {
                            selectedItem.amount -= 1;
                            equipment.setEquipment('Mainhand', selectedItem);
                        } else {
                            equipment.setEquipment('Mainhand', undefined); // Clear the slot if only 1 item left
                        }
                    }
                    return; // Exit the function after placing the block
                }
            }
            const currentState = block.permutation.getState('old_villagers_plus:open');
            const newOpenState = !currentState;
            const sound = newOpenState ? 'open.fence_gate' : 'close.fence_gate';
            const rotationAngle = player.getRotation().y;
            const newCardinalDirection = getNewCardinalDirection(block.permutation.getState('minecraft:cardinal_direction'), rotationAngle);
            const newPermutation = BlockPermutation.resolve(block.typeId, {
                ...block.permutation.getAllStates(),
                'old_villagers_plus:open': newOpenState,
                'minecraft:cardinal_direction': newCardinalDirection
            });
            block.setPermutation(newPermutation);
            block.dimension.playSound(sound, block.location);
            const aboveBlock = block.above();
            if (aboveBlock.typeId === 'old_villagers_plus:grey_fence_gate' && aboveBlock.permutation.getState('old_villagers_plus:invisible')) {
                const aboveCurrentState = aboveBlock.permutation.getState('old_villagers_plus:open');
                if (aboveCurrentState !== newOpenState) {
                    const newAbovePermutation = BlockPermutation.resolve(aboveBlock.typeId, {
                        ...aboveBlock.permutation.getAllStates(),
                        'old_villagers_plus:open': newOpenState
                    });
                    aboveBlock.setPermutation(newAbovePermutation);
                }
            }
        }
    });
});

//Light Blue Fence Gate
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_light_blue_fence_gate', {
        onPlayerInteract(e) {
            const { block, player, face } = e;
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            if (selectedItem && face === 'Up' && BlockTypes.get(selectedItem.typeId)) {
                const aboveBlock = block.above();
                if (aboveBlock.typeId === 'old_villagers_plus:light_blue_fence_gate') {
                    aboveBlock.setType(selectedItem.typeId);
                    if (player.getGameMode() !== "creative") {
                        if (selectedItem.amount > 1) {
                            selectedItem.amount -= 1;
                            equipment.setEquipment('Mainhand', selectedItem);
                        } else {
                            equipment.setEquipment('Mainhand', undefined); // Clear the slot if only 1 item left
                        }
                    }
                    return; // Exit the function after placing the block
                }
            }
            const currentState = block.permutation.getState('old_villagers_plus:open');
            const newOpenState = !currentState;
            const sound = newOpenState ? 'open.fence_gate' : 'close.fence_gate';
            const rotationAngle = player.getRotation().y;
            const newCardinalDirection = getNewCardinalDirection(block.permutation.getState('minecraft:cardinal_direction'), rotationAngle);
            const newPermutation = BlockPermutation.resolve(block.typeId, {
                ...block.permutation.getAllStates(),
                'old_villagers_plus:open': newOpenState,
                'minecraft:cardinal_direction': newCardinalDirection
            });
            block.setPermutation(newPermutation);
            block.dimension.playSound(sound, block.location);
            const aboveBlock = block.above();
            if (aboveBlock.typeId === 'old_villagers_plus:light_blue_fence_gate' && aboveBlock.permutation.getState('old_villagers_plus:invisible')) {
                const aboveCurrentState = aboveBlock.permutation.getState('old_villagers_plus:open');
                if (aboveCurrentState !== newOpenState) {
                    const newAbovePermutation = BlockPermutation.resolve(aboveBlock.typeId, {
                        ...aboveBlock.permutation.getAllStates(),
                        'old_villagers_plus:open': newOpenState
                    });
                    aboveBlock.setPermutation(newAbovePermutation);
                }
            }
        }
    });
});

//Light Grey Fence Gate
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_light_grey_fence_gate', {
        onPlayerInteract(e) {
            const { block, player, face } = e;
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            if (selectedItem && face === 'Up' && BlockTypes.get(selectedItem.typeId)) {
                const aboveBlock = block.above();
                if (aboveBlock.typeId === 'old_villagers_plus:light_grey_fence_gate') {
                    aboveBlock.setType(selectedItem.typeId);
                    if (player.getGameMode() !== "creative") {
                        if (selectedItem.amount > 1) {
                            selectedItem.amount -= 1;
                            equipment.setEquipment('Mainhand', selectedItem);
                        } else {
                            equipment.setEquipment('Mainhand', undefined); // Clear the slot if only 1 item left
                        }
                    }
                    return; // Exit the function after placing the block
                }
            }
            const currentState = block.permutation.getState('old_villagers_plus:open');
            const newOpenState = !currentState;
            const sound = newOpenState ? 'open.fence_gate' : 'close.fence_gate';
            const rotationAngle = player.getRotation().y;
            const newCardinalDirection = getNewCardinalDirection(block.permutation.getState('minecraft:cardinal_direction'), rotationAngle);
            const newPermutation = BlockPermutation.resolve(block.typeId, {
                ...block.permutation.getAllStates(),
                'old_villagers_plus:open': newOpenState,
                'minecraft:cardinal_direction': newCardinalDirection
            });
            block.setPermutation(newPermutation);
            block.dimension.playSound(sound, block.location);
            const aboveBlock = block.above();
            if (aboveBlock.typeId === 'old_villagers_plus:light_grey_fence_gate' && aboveBlock.permutation.getState('old_villagers_plus:invisible')) {
                const aboveCurrentState = aboveBlock.permutation.getState('old_villagers_plus:open');
                if (aboveCurrentState !== newOpenState) {
                    const newAbovePermutation = BlockPermutation.resolve(aboveBlock.typeId, {
                        ...aboveBlock.permutation.getAllStates(),
                        'old_villagers_plus:open': newOpenState
                    });
                    aboveBlock.setPermutation(newAbovePermutation);
                }
            }
        }
    });
});

//Orange Fence Gate
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_orange_fence_gate', {
        onPlayerInteract(e) {
            const { block, player, face } = e;
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            if (selectedItem && face === 'Up' && BlockTypes.get(selectedItem.typeId)) {
                const aboveBlock = block.above();
                if (aboveBlock.typeId === 'old_villagers_plus:orange_fence_gate') {
                    aboveBlock.setType(selectedItem.typeId);
                    if (player.getGameMode() !== "creative") {
                        if (selectedItem.amount > 1) {
                            selectedItem.amount -= 1;
                            equipment.setEquipment('Mainhand', selectedItem);
                        } else {
                            equipment.setEquipment('Mainhand', undefined); // Clear the slot if only 1 item left
                        }
                    }
                    return; // Exit the function after placing the block
                }
            }
            const currentState = block.permutation.getState('old_villagers_plus:open');
            const newOpenState = !currentState;
            const sound = newOpenState ? 'open.fence_gate' : 'close.fence_gate';
            const rotationAngle = player.getRotation().y;
            const newCardinalDirection = getNewCardinalDirection(block.permutation.getState('minecraft:cardinal_direction'), rotationAngle);
            const newPermutation = BlockPermutation.resolve(block.typeId, {
                ...block.permutation.getAllStates(),
                'old_villagers_plus:open': newOpenState,
                'minecraft:cardinal_direction': newCardinalDirection
            });
            block.setPermutation(newPermutation);
            block.dimension.playSound(sound, block.location);
            const aboveBlock = block.above();
            if (aboveBlock.typeId === 'old_villagers_plus:orange_fence_gate' && aboveBlock.permutation.getState('old_villagers_plus:invisible')) {
                const aboveCurrentState = aboveBlock.permutation.getState('old_villagers_plus:open');
                if (aboveCurrentState !== newOpenState) {
                    const newAbovePermutation = BlockPermutation.resolve(aboveBlock.typeId, {
                        ...aboveBlock.permutation.getAllStates(),
                        'old_villagers_plus:open': newOpenState
                    });
                    aboveBlock.setPermutation(newAbovePermutation);
                }
            }
        }
    });
});

//Pink Fence Gate
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_pink_fence_gate', {
        onPlayerInteract(e) {
            const { block, player, face } = e;
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            if (selectedItem && face === 'Up' && BlockTypes.get(selectedItem.typeId)) {
                const aboveBlock = block.above();
                if (aboveBlock.typeId === 'old_villagers_plus:pink_fence_gate') {
                    aboveBlock.setType(selectedItem.typeId);
                    if (player.getGameMode() !== "creative") {
                        if (selectedItem.amount > 1) {
                            selectedItem.amount -= 1;
                            equipment.setEquipment('Mainhand', selectedItem);
                        } else {
                            equipment.setEquipment('Mainhand', undefined); // Clear the slot if only 1 item left
                        }
                    }
                    return; // Exit the function after placing the block
                }
            }
            const currentState = block.permutation.getState('old_villagers_plus:open');
            const newOpenState = !currentState;
            const sound = newOpenState ? 'open.fence_gate' : 'close.fence_gate';
            const rotationAngle = player.getRotation().y;
            const newCardinalDirection = getNewCardinalDirection(block.permutation.getState('minecraft:cardinal_direction'), rotationAngle);
            const newPermutation = BlockPermutation.resolve(block.typeId, {
                ...block.permutation.getAllStates(),
                'old_villagers_plus:open': newOpenState,
                'minecraft:cardinal_direction': newCardinalDirection
            });
            block.setPermutation(newPermutation);
            block.dimension.playSound(sound, block.location);
            const aboveBlock = block.above();
            if (aboveBlock.typeId === 'old_villagers_plus:pink_fence_gate' && aboveBlock.permutation.getState('old_villagers_plus:invisible')) {
                const aboveCurrentState = aboveBlock.permutation.getState('old_villagers_plus:open');
                if (aboveCurrentState !== newOpenState) {
                    const newAbovePermutation = BlockPermutation.resolve(aboveBlock.typeId, {
                        ...aboveBlock.permutation.getAllStates(),
                        'old_villagers_plus:open': newOpenState
                    });
                    aboveBlock.setPermutation(newAbovePermutation);
                }
            }
        }
    });
});

//Purple Fence Gate
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_purple_fence_gate', {
        onPlayerInteract(e) {
            const { block, player, face } = e;
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            if (selectedItem && face === 'Up' && BlockTypes.get(selectedItem.typeId)) {
                const aboveBlock = block.above();
                if (aboveBlock.typeId === 'old_villagers_plus:purple_fence_gate') {
                    aboveBlock.setType(selectedItem.typeId);
                    if (player.getGameMode() !== "creative") {
                        if (selectedItem.amount > 1) {
                            selectedItem.amount -= 1;
                            equipment.setEquipment('Mainhand', selectedItem);
                        } else {
                            equipment.setEquipment('Mainhand', undefined); // Clear the slot if only 1 item left
                        }
                    }
                    return; // Exit the function after placing the block
                }
            }
            const currentState = block.permutation.getState('old_villagers_plus:open');
            const newOpenState = !currentState;
            const sound = newOpenState ? 'open.fence_gate' : 'close.fence_gate';
            const rotationAngle = player.getRotation().y;
            const newCardinalDirection = getNewCardinalDirection(block.permutation.getState('minecraft:cardinal_direction'), rotationAngle);
            const newPermutation = BlockPermutation.resolve(block.typeId, {
                ...block.permutation.getAllStates(),
                'old_villagers_plus:open': newOpenState,
                'minecraft:cardinal_direction': newCardinalDirection
            });
            block.setPermutation(newPermutation);
            block.dimension.playSound(sound, block.location);
            const aboveBlock = block.above();
            if (aboveBlock.typeId === 'old_villagers_plus:purple_fence_gate' && aboveBlock.permutation.getState('old_villagers_plus:invisible')) {
                const aboveCurrentState = aboveBlock.permutation.getState('old_villagers_plus:open');
                if (aboveCurrentState !== newOpenState) {
                    const newAbovePermutation = BlockPermutation.resolve(aboveBlock.typeId, {
                        ...aboveBlock.permutation.getAllStates(),
                        'old_villagers_plus:open': newOpenState
                    });
                    aboveBlock.setPermutation(newAbovePermutation);
                }
            }
        }
    });
});

//Red Fence Gate
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_red_fence_gate', {
        onPlayerInteract(e) {
            const { block, player, face } = e;
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            if (selectedItem && face === 'Up' && BlockTypes.get(selectedItem.typeId)) {
                const aboveBlock = block.above();
                if (aboveBlock.typeId === 'old_villagers_plus:red_fence_gate') {
                    aboveBlock.setType(selectedItem.typeId);
                    if (player.getGameMode() !== "creative") {
                        if (selectedItem.amount > 1) {
                            selectedItem.amount -= 1;
                            equipment.setEquipment('Mainhand', selectedItem);
                        } else {
                            equipment.setEquipment('Mainhand', undefined); // Clear the slot if only 1 item left
                        }
                    }
                    return; // Exit the function after placing the block
                }
            }
            const currentState = block.permutation.getState('old_villagers_plus:open');
            const newOpenState = !currentState;
            const sound = newOpenState ? 'open.fence_gate' : 'close.fence_gate';
            const rotationAngle = player.getRotation().y;
            const newCardinalDirection = getNewCardinalDirection(block.permutation.getState('minecraft:cardinal_direction'), rotationAngle);
            const newPermutation = BlockPermutation.resolve(block.typeId, {
                ...block.permutation.getAllStates(),
                'old_villagers_plus:open': newOpenState,
                'minecraft:cardinal_direction': newCardinalDirection
            });
            block.setPermutation(newPermutation);
            block.dimension.playSound(sound, block.location);
            const aboveBlock = block.above();
            if (aboveBlock.typeId === 'old_villagers_plus:red_fence_gate' && aboveBlock.permutation.getState('old_villagers_plus:invisible')) {
                const aboveCurrentState = aboveBlock.permutation.getState('old_villagers_plus:open');
                if (aboveCurrentState !== newOpenState) {
                    const newAbovePermutation = BlockPermutation.resolve(aboveBlock.typeId, {
                        ...aboveBlock.permutation.getAllStates(),
                        'old_villagers_plus:open': newOpenState
                    });
                    aboveBlock.setPermutation(newAbovePermutation);
                }
            }
        }
    });
});

//White Fence Gate
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_white_fence_gate', {
        onPlayerInteract(e) {
            const { block, player, face } = e;
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            if (selectedItem && face === 'Up' && BlockTypes.get(selectedItem.typeId)) {
                const aboveBlock = block.above();
                if (aboveBlock.typeId === 'old_villagers_plus:white_fence_gate') {
                    aboveBlock.setType(selectedItem.typeId);
                    if (player.getGameMode() !== "creative") {
                        if (selectedItem.amount > 1) {
                            selectedItem.amount -= 1;
                            equipment.setEquipment('Mainhand', selectedItem);
                        } else {
                            equipment.setEquipment('Mainhand', undefined); // Clear the slot if only 1 item left
                        }
                    }
                    return; // Exit the function after placing the block
                }
            }
            const currentState = block.permutation.getState('old_villagers_plus:open');
            const newOpenState = !currentState;
            const sound = newOpenState ? 'open.fence_gate' : 'close.fence_gate';
            const rotationAngle = player.getRotation().y;
            const newCardinalDirection = getNewCardinalDirection(block.permutation.getState('minecraft:cardinal_direction'), rotationAngle);
            const newPermutation = BlockPermutation.resolve(block.typeId, {
                ...block.permutation.getAllStates(),
                'old_villagers_plus:open': newOpenState,
                'minecraft:cardinal_direction': newCardinalDirection
            });
            block.setPermutation(newPermutation);
            block.dimension.playSound(sound, block.location);
            const aboveBlock = block.above();
            if (aboveBlock.typeId === 'old_villagers_plus:white_fence_gate' && aboveBlock.permutation.getState('old_villagers_plus:invisible')) {
                const aboveCurrentState = aboveBlock.permutation.getState('old_villagers_plus:open');
                if (aboveCurrentState !== newOpenState) {
                    const newAbovePermutation = BlockPermutation.resolve(aboveBlock.typeId, {
                        ...aboveBlock.permutation.getAllStates(),
                        'old_villagers_plus:open': newOpenState
                    });
                    aboveBlock.setPermutation(newAbovePermutation);
                }
            }
        }
    });
});

//Yellow Fence Gate
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_yellow_fence_gate', {
        onPlayerInteract(e) {
            const { block, player, face } = e;
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            if (selectedItem && face === 'Up' && BlockTypes.get(selectedItem.typeId)) {
                const aboveBlock = block.above();
                if (aboveBlock.typeId === 'old_villagers_plus:yellow_fence_gate') {
                    aboveBlock.setType(selectedItem.typeId);
                    if (player.getGameMode() !== "creative") {
                        if (selectedItem.amount > 1) {
                            selectedItem.amount -= 1;
                            equipment.setEquipment('Mainhand', selectedItem);
                        } else {
                            equipment.setEquipment('Mainhand', undefined); // Clear the slot if only 1 item left
                        }
                    }
                    return; // Exit the function after placing the block
                }
            }
            const currentState = block.permutation.getState('old_villagers_plus:open');
            const newOpenState = !currentState;
            const sound = newOpenState ? 'open.fence_gate' : 'close.fence_gate';
            const rotationAngle = player.getRotation().y;
            const newCardinalDirection = getNewCardinalDirection(block.permutation.getState('minecraft:cardinal_direction'), rotationAngle);
            const newPermutation = BlockPermutation.resolve(block.typeId, {
                ...block.permutation.getAllStates(),
                'old_villagers_plus:open': newOpenState,
                'minecraft:cardinal_direction': newCardinalDirection
            });
            block.setPermutation(newPermutation);
            block.dimension.playSound(sound, block.location);
            const aboveBlock = block.above();
            if (aboveBlock.typeId === 'old_villagers_plus:yellow_fence_gate' && aboveBlock.permutation.getState('old_villagers_plus:invisible')) {
                const aboveCurrentState = aboveBlock.permutation.getState('old_villagers_plus:open');
                if (aboveCurrentState !== newOpenState) {
                    const newAbovePermutation = BlockPermutation.resolve(aboveBlock.typeId, {
                        ...aboveBlock.permutation.getAllStates(),
                        'old_villagers_plus:open': newOpenState
                    });
                    aboveBlock.setPermutation(newAbovePermutation);
                }
            }
        }
    });
});

//Villager Spawner Block

//Villager Spawner 1
world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_villager_spawner1', {
        onPlayerInteract: e => {
            const { block } = e;
            const { x, y, z } = block.location
            block.dimension.runCommand(`summon old_villagers_plus:librarian_spawn ${x + 1} ${y + 1} ${z - 1}`)
            block.dimension.runCommand(`summon old_villagers_plus:villager_spawn ${x + 1} ${y + 1} ${z + 1}`)
            block.dimension.runCommand(`summon old_villagers_plus:blacksmith_spawn ${x - 1} ${y + 1} ${z - 1}`)
            block.dimension.runCommand(`summon old_villagers_plus:butcher_spawn ${x - 1} ${y + 1} ${z + 2}`)
            block.dimension.runCommand(`summon old_villagers_plus:villager_spawn ${x - 2} ${y + 1} ${z + 1}`)
            block.setType('air');
            block.dimension.playSound('xp_old', block.location)
            block.dimension.runCommand(`summon old_villagers_plus:iron_golem_spawn ${x} ${y + 1} ${z}`)
        }
    });
});

//Villager Spawner 2
world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_villager_spawner2', {
        onPlayerInteract: e => {
            const { block } = e;
            const { x, y, z } = block.location
            block.dimension.runCommand(`summon old_villagers_plus:villager_spawn ${x + 1} ${y + 1} ${z + 1}`)
            block.dimension.runCommand(`summon old_villagers_plus:villager_spawn ${x - 2} ${y + 1} ${z - 1}`)
            block.dimension.runCommand(`summon old_villagers_plus:villager_spawn ${x - 1} ${y + 1} ${z - 2}`)
            block.dimension.runCommand(`summon old_villagers_plus:villager_spawn ${x + 1} ${y + 1} ${z + 2}`)
            block.dimension.runCommand(`summon old_villagers_plus:priest_spawn ${x + 1} ${y + 1} ${z - 2}`)
            block.setType('air');
            block.dimension.playSound('xp_old', block.location)
            block.dimension.runCommand(`summon old_villagers_plus:iron_golem_spawn ${x} ${y + 1} ${z}`)
        }
    });
});

//Villager Spawner 3
world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_villager_spawner3', {
        onPlayerInteract: e => {
            const { block } = e;
            const { x, y, z } = block.location
            block.dimension.runCommand(`summon old_villagers_plus:villager_spawn ${x + 1} ${y + 1} ${z + 1}`)
            block.dimension.runCommand(`summon old_villagers_plus:villager_spawn ${x - 1} ${y + 1} ${z + 1}`)
            block.dimension.runCommand(`summon old_villagers_plus:villager_spawn ${x - 2} ${y + 1} ${z - 1}`)
            block.dimension.runCommand(`summon old_villagers_plus:villager_spawn ${x + 1} ${y + 1} ${z - 2}`)
            block.setType('air');
            block.dimension.playSound('xp_old', block.location)
            block.dimension.runCommand(`summon old_villagers_plus:iron_golem_spawn ${x} ${y + 1} ${z}`)
        }
    });
});

//Villager Spawner 4
world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_villager_spawner4', {
        onPlayerInteract: e => {
            const { block } = e;
            const { x, y, z } = block.location
            block.dimension.runCommand(`summon old_villagers_plus:villager_spawn ${x - 1} ${y + 1} ${z - 1}`)
            block.dimension.runCommand(`summon old_villagers_plus:villager_spawn ${x + 1} ${y + 1} ${z - 1}`)
            block.dimension.runCommand(`summon old_villagers_plus:villager_spawn ${x - 1} ${y + 1} ${z + 1}`)
            block.dimension.runCommand(`summon old_villagers_plus:blacksmith_spawn ${x - 1} ${y + 1} ${z + 2}`)
            block.setType('air');
            block.dimension.playSound('xp_old', block.location)
            block.dimension.runCommand(`summon old_villagers_plus:iron_golem_spawn ${x} ${y + 1} ${z}`)
        }
    });
});

//Cherry Villager Spawner 1
world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_cherry_villager_spawner1', {
        onPlayerInteract: e => {
            const { block } = e;
            const { x, y, z } = block.location
            block.dimension.runCommand(`summon old_villagers_plus:librarian_spawn ${x + 1} ${y + 1} ${z - 1}`)
            block.dimension.runCommand(`summon old_villagers_plus:villager_spawn ${x + 1} ${y + 1} ${z + 1}`)
            block.dimension.runCommand(`summon old_villagers_plus:blacksmith_spawn ${x - 1} ${y + 1} ${z - 1}`)
            block.dimension.runCommand(`summon old_villagers_plus:butcher_spawn ${x - 2} ${y + 1} ${z + 1}`)
            block.dimension.runCommand(`summon old_villagers_plus:villager_spawn ${x - 1} ${y + 1} ${z + 2}`)
            block.setType('air');
            block.dimension.playSound('xp_old', block.location)
            block.dimension.runCommand(`summon old_villagers_plus:love_golem_spawn ${x} ${y + 1} ${z}`)
        }
    });
});

//Cherry Villager Spawner 2
world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_cherry_villager_spawner2', {
        onPlayerInteract: e => {
            const { block } = e;
            const { x, y, z } = block.location
            block.dimension.runCommand(`summon old_villagers_plus:villager_spawn ${x + 1} ${y + 1} ${z + 1}`)
            block.dimension.runCommand(`summon old_villagers_plus:villager_spawn ${x - 1} ${y + 1} ${z - 1}`)
            block.dimension.runCommand(`summon old_villagers_plus:villager_spawn ${x - 2} ${y + 1} ${z - 1}`)
            block.dimension.runCommand(`summon old_villagers_plus:villager_spawn ${x + 2} ${y + 1} ${z + 1}`)
            block.dimension.runCommand(`summon old_villagers_plus:priest_spawn ${x + 1} ${y + 1} ${z - 2}`)
            block.setType('air');
            block.dimension.playSound('xp_old', block.location)
            block.dimension.runCommand(`summon old_villagers_plus:love_golem_spawn ${x} ${y + 1} ${z}`)
        }
    });
});

//Cherry Villager Spawner 3
world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_cherry_villager_spawner3', {
        onPlayerInteract: e => {
            const { block } = e;
            const { x, y, z } = block.location
            block.dimension.runCommand(`summon old_villagers_plus:villager_spawn ${x + 1} ${y + 1} ${z + 1}`)
            block.dimension.runCommand(`summon old_villagers_plus:villager_spawn ${x - 1} ${y + 1} ${z + 1}`)
            block.dimension.runCommand(`summon old_villagers_plus:villager_spawn ${x - 1} ${y + 1} ${z - 2}`)
            block.dimension.runCommand(`summon old_villagers_plus:villager_spawn ${x + 2} ${y + 1} ${z - 1}`)
            block.setType('air');
            block.dimension.playSound('xp_old', block.location)
            block.dimension.runCommand(`summon old_villagers_plus:love_golem_spawn ${x} ${y + 1} ${z}`)
        }
    });
});

//Cherry Villager Spawner 4
world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('old_villagers_plus:on_interact_cherry_villager_spawner4', {
        onPlayerInteract: e => {
            const { block } = e;
            const { x, y, z } = block.location
            block.dimension.runCommand(`summon old_villagers_plus:villager_spawn ${x - 1} ${y + 1} ${z - 1}`)
            block.dimension.runCommand(`summon old_villagers_plus:villager_spawn ${x - 2} ${y + 1} ${z - 1}`)
            block.dimension.runCommand(`summon old_villagers_plus:villager_spawn ${x - 1} ${y + 1} ${z + 2}`)
            block.dimension.runCommand(`summon old_villagers_plus:blacksmith_spawn ${x - 2} ${y + 1} ${z + 1}`)
            block.setType('air');
            block.dimension.playSound('xp_old', block.location)
            block.dimension.runCommand(`summon old_villagers_plus:love_golem_spawn ${x} ${y + 1} ${z}`)
        }
    });
});