import { system, world } from "@minecraft/server";

//USE ITEMS

//Vindicator Axe
world.afterEvents.itemUse.subscribe(data => {
    if (data.itemStack.typeId == "old_villagers_plus:vindicator_axe") {
        system.run(() => {
            const player = data.source;
            player.runCommandAsync("function vindicator_axe_summon");
        });
    }

    return;
});

//Gravity Wand
world.afterEvents.itemUse.subscribe(data => {
    const { itemStack: item, source: player } = data;
    if (item.typeId !== 'old_villagers_plus:gravity_wand') return;
    const cooldown = item.getComponent('cooldown');
    const remainingCooldown = cooldown?.getCooldownTicksRemaining(player);
    if (remainingCooldown === 0) {
        cooldown.startCooldown(player);
        player.runCommandAsync("playsound mob.enchanter.spell @a[r=16]");
        if (item.getComponent('durability').damage === item.getComponent('durability').maxDurability) {
            player.getComponent('equippable').setEquipment('Mainhand', undefined);
        }
        else {
            item.getComponent('durability').damage += 5
            player.getComponent('equippable').setEquipment('Mainhand', item);
        }
    }
    else {
        player.onScreenDisplay.setActionBar('Item is in cooldown');
    }
});

//Ice Wand
world.afterEvents.itemUse.subscribe(data => {
    const { itemStack: item, source: player } = data;
    if (item.typeId !== 'old_villagers_plus:ice_wand') return;
    const cooldown = item.getComponent('cooldown');
    const remainingCooldown = cooldown?.getCooldownTicksRemaining(player);
    if (remainingCooldown === 0) {
        cooldown.startCooldown(player);
        player.runCommandAsync("playsound mob.enchanter.spell @a[r=16]");
        if (item.getComponent('durability').damage === item.getComponent('durability').maxDurability) {
            player.getComponent('equippable').setEquipment('Mainhand', undefined);
        }
        else {
            item.getComponent('durability').damage += 5
            player.getComponent('equippable').setEquipment('Mainhand', item);
        }
    }
    else {
        player.onScreenDisplay.setActionBar('Item is in cooldown');
    }
});

//Old Totem Of Undying
world.afterEvents.itemUse.subscribe(data => {
    const { itemStack: item, source: player } = data;
    if (item.typeId !== 'old_villagers_plus:old_totem_of_undying') return;
    const cooldown = item.getComponent('cooldown');
    const remainingCooldown = cooldown?.getCooldownTicksRemaining(player);
    if (remainingCooldown === 0) {
        cooldown.startCooldown(player);
        player.runCommandAsync("function old_totem_of_undying");
    }
    else {
        player.onScreenDisplay.setActionBar('Item is in cooldown');
    }
});

//Rune Of Time
world.afterEvents.itemUse.subscribe(data => {
    const { itemStack: item, source: player } = data;
    if (item.typeId !== 'old_villagers_plus:rune_of_time') return;
    const cooldown = item.getComponent('cooldown');
    const remainingCooldown = cooldown?.getCooldownTicksRemaining(player);
    if (remainingCooldown === 0) {
        cooldown.startCooldown(player);
        player.runCommandAsync("function rune_of_time");
    }
    else {
        player.onScreenDisplay.setActionBar('Item is in cooldown');
    }
});

//POTIONS
//Potion of Love
world.afterEvents.itemCompleteUse.subscribe(data => {
    if (data.itemStack.typeId == "old_villagers_plus:potion_love") {
        system.run(() => {
            const player = data.source;
            player.runCommandAsync("effect @e[rm=1,r=4,family=!monster] regeneration 10 3");
            player.runCommandAsync("give @s[m=!c] glass_bottle 1");
        });
    }

    return;
});

world.afterEvents.itemCompleteUse.subscribe(data => {
    if (data.itemStack.typeId == "old_villagers_plus:potion_love_extended_time") {
        system.run(() => {
            const player = data.source;
            player.runCommandAsync("effect @e[rm=1,r=4,family=!monster] regeneration 20 3");
            player.runCommandAsync("give @s[m=!c] glass_bottle 1");
        });
    }

    return;
});

world.afterEvents.itemCompleteUse.subscribe(data => {
    if (data.itemStack.typeId == "old_villagers_plus:potion_love_amplified") {
        system.run(() => {
            const player = data.source;
            player.runCommandAsync("effect @e[rm=1,r=4,family=!monster] regeneration 10 5");
            player.runCommandAsync("give @s[m=!c] glass_bottle 1");
        });
    }

    return;
});

//Potion of Caring
world.afterEvents.itemCompleteUse.subscribe(data => {
    if (data.itemStack.typeId == "old_villagers_plus:potion_caring") {
        system.run(() => {
            const player = data.source;
            player.runCommandAsync("effect @e[rm=1,r=4,family=!monster] resistance 10 3");
            player.runCommandAsync("give @s[m=!c] glass_bottle 1");
        });
    }

    return;
});

world.afterEvents.itemCompleteUse.subscribe(data => {
    if (data.itemStack.typeId == "old_villagers_plus:potion_caring_extended_time") {
        system.run(() => {
            const player = data.source;
            player.runCommandAsync("effect @e[rm=1,r=4,family=!monster] resistance 20 3");
            player.runCommandAsync("give @s[m=!c] glass_bottle 1");
        });
    }

    return;
});

world.afterEvents.itemCompleteUse.subscribe(data => {
    if (data.itemStack.typeId == "old_villagers_plus:potion_caring_amplified") {
        system.run(() => {
            const player = data.source;
            player.runCommandAsync("effect @e[rm=1,r=4,family=!monster] resistance 10 5");
            player.runCommandAsync("give @s[m=!c] glass_bottle 1");
        });
    }

    return;
});

//Potion of Fun
world.afterEvents.itemCompleteUse.subscribe(data => {
    if (data.itemStack.typeId == "old_villagers_plus:potion_fun") {
        system.run(() => {
            const player = data.source;
            player.runCommandAsync("summon old_villagers_plus:potion_fun_effect ~ ~ ~");
            player.runCommandAsync("give @s[m=!c] glass_bottle 1");
        });
    }

    return;
});

world.afterEvents.itemCompleteUse.subscribe(data => {
    if (data.itemStack.typeId == "old_villagers_plus:potion_fun_amplified") {
        system.run(() => {
            const player = data.source;
            player.runCommandAsync("summon old_villagers_plus:potion_fun_amplified_effect ~ ~ ~");
            player.runCommandAsync("give @s[m=!c] glass_bottle 1");
        });
    }

    return;
});

//Potion of Happiness
world.afterEvents.itemCompleteUse.subscribe(data => {
    if (data.itemStack.typeId == "old_villagers_plus:potion_happiness") {
        system.run(() => {
            const player = data.source;
            player.runCommandAsync("effect @s weakness 0");
            player.runCommandAsync("effect @s slowness 0");
            player.runCommandAsync("effect @s levitation 0");
            player.runCommandAsync("effect @s mining_fatigue 0");
            player.runCommandAsync("give @s[m=!c] glass_bottle 1");
        });
    }

    return;
});

world.afterEvents.itemCompleteUse.subscribe(data => {
    if (data.itemStack.typeId == "old_villagers_plus:potion_happiness_amplified") {
        system.run(() => {
            const player = data.source;
            player.runCommandAsync("effect @s darkness 0");
            player.runCommandAsync("effect @s blindness 0");
            player.runCommandAsync("effect @s nausea 0");
            player.runCommandAsync("effect @s levitation 0");
            player.runCommandAsync("effect @s slowness 0");
            player.runCommandAsync("effect @s mining_fatigue 0");
            player.runCommandAsync("effect @s weakness 0");
            player.runCommandAsync("give @s[m=!c] glass_bottle 1");
        });
    }

    return;
});

//Potion of Sharing
world.afterEvents.itemCompleteUse.subscribe(data => {
    if (data.itemStack.typeId == "old_villagers_plus:potion_sharing") {
        system.run(() => {
            const player = data.source;
            player.runCommandAsync("summon old_villagers_plus:potion_sharing_effect ~ ~ ~");
            player.runCommandAsync("give @s[m=!c] glass_bottle 1");
        });
    }

    return;
});

world.afterEvents.itemCompleteUse.subscribe(data => {
    if (data.itemStack.typeId == "old_villagers_plus:potion_sharing_amplified") {
        system.run(() => {
            const player = data.source;
            player.runCommandAsync("summon old_villagers_plus:potion_sharing_amplified_effect ~ ~ ~");
            player.runCommandAsync("give @s[m=!c] glass_bottle 1");
        });
    }

    return;
});